(function () {
    'use strict';

    class SceneManager$1 {

        static open(_ui) {
            switch (_ui) {
                case SceneManager$1.UI_MAIN:
                    Laya.Scene.open("main.scene");
                    SceneManager$1.gameUI = null;
                    break;
                case SceneManager$1.UI_GAME:
                    Laya.Scene.open("fps.scene");
                    SceneManager$1.mainUI = null;
                    break;
            }
            SceneManager$1.curScene = _ui;
        }
        static init() {
            Laya.Scene.open("loading.scene");
        }
        //开始关卡
        static start(id) {
            if (id <= SceneManager$1.maxStage) {
                SceneManager$1.curStage = id;
            }
            Laya.Scene.open("loading.scene");
        }
        static GoBackToMain() {
            let ss = SceneManager$1.resScene;
            SceneManager$1.resScene.destroy();

            // SceneManager.resModels.destroy();
            SceneManager$1.resScene = null;
            // SceneManager.resModels = null;
            SceneManager$1.player = null;
            SceneManager$1.boss = null;
            SceneManager$1.camera = null;
            SceneManager$1.clearData();
            SceneManager$1.open(SceneManager$1.UI_MAIN);
        }
        static clearData() {
            SceneManager$1.monsterList = [];
        }
        static RandomInt(min, max) {
            return Math.round(Math.random() * (max - min) + min);
        }

        static NextStage(id) {
            SceneManager$1.resScene.destroy();
            // SceneManager.resModels.destroy();
            SceneManager$1.resScene = null;
            // SceneManager.resModels = null;
            SceneManager$1.player = null;
            SceneManager$1.camera = null;
            SceneManager$1.boss = null;
            SceneManager$1.clearData();
            SceneManager$1.start(id);
        }
        static ShowMessage(str) {
            if (SceneManager$1.messageUI == null) {
                Laya.Scene.open("message.scene", false, [1, str]);
            }
            else {
                SceneManager$1.messageUI.ShowRedInfo(str);
            }
        }
        static ShowMoneyAdd(v) {
            if (SceneManager$1.messageUI == null) {
                Laya.Scene.open("message.scene", false, [3, v]);
            }
            else {
                SceneManager$1.messageUI.ShowMoneyAdd(v);
            }
        }
        static ShowMoneyDel(v) {
            if (SceneManager$1.messageUI == null) {
                Laya.Scene.open("message.scene", false, [2, v]);
            }
            else {
                SceneManager$1.messageUI.ShowMoneyDel(v);
            }
        }

        static PlaySound(name, loop = 1) {
            // var sn = SceneManager.sourceURL + "res/sound/" + name + SceneManager.soundStyle;
            var sn = "res/sound/" + name + SceneManager$1.soundStyle;

            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playSound(sn, loop);
                if (SceneManager$1.hasPlayedSound.indexOf(sn) == -1) {
                    SceneManager$1.hasPlayedSound.push(sn);
                    Laya.SoundManager.playSound(sn, loop);
                }
            }));
        }
        static StopSound(name) {
            if (name == null) {
                Laya.SoundManager.stopAll();
            }
            else {
                // var sn = SceneManager.sourceURL + "res/sound/" + name + ".wav";
                var sn = "res/sound/" + name + ".wav";
                // console.log("SceneManager       StopSound       sn:", sn);
                Laya.SoundManager.stopSound(sn);
            }
        }
        static OpenSound() {
            Laya.SoundManager.muted = false;
        }
        static CloseSound() {
            Laya.SoundManager.muted = true;
        }
        static PlayMusic() {
            // var sn = SceneManager.sourceURL + "res/sound/bg" + SceneManager.soundStyle;
            var sn = "res/sound/bg" + SceneManager$1.soundStyle;
            // console.log("SceneManager       PlayMusic       sn:", sn);
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                // console.log("SceneManager       PlayMusic       背景音乐加载成功:", sn);
                Laya.SoundManager.playMusic(sn, 0);
                if (SceneManager$1.hasPlayedSound.indexOf(sn) == -1) {
                    SceneManager$1.hasPlayedSound.push(sn);
                    Laya.SoundManager.playMusic(sn, 0);
                }
            }));
        }
        static SetVolume(v) {
            Laya.SoundManager.setMusicVolume(v);
            Laya.SoundManager.setSoundVolume(v);
        }
        static SetRocker(v) {
            SceneManager$1.rocker = v;
        }

        static InitAreaInfo() {
            SceneManager$1.itemPos = [];
            SceneManager$1.playerPos = [];
            var box = SceneManager$1.resScene.getChildByName("box");
            for (var i = 0; i < box.numChildren; i++) {
                var obj = box.getChildAt(i);
                SceneManager$1.itemPos.push(obj.transform.position.clone());
            }
            var initPos = SceneManager$1.resScene.getChildByName("initPos");
            for (var i = 0; i < initPos.numChildren; i++) {
                var obj = initPos.getChildAt(i);
                if (obj.name != "player")
                    SceneManager$1.playerPos.push(obj.transform.position.clone());
            }
        }
        static RandomName() {
            var n1 = SceneManager$1.RandomInt(0, SceneManager$1.Name1.length - 1);
            var name1 = SceneManager$1.Name1[n1];
            var n2 = SceneManager$1.RandomInt(0, SceneManager$1.Name2.length - 1);
            var name2 = SceneManager$1.Name2[n2];
            return name1 + name2;
        }
    }
    SceneManager$1.soundStyle = ".wav";
    SceneManager$1.hasPlayedSound = [];

    SceneManager$1.playerSpeed = 8;  //玩家速度  8
    SceneManager$1.monsterSpeed = 4;  //敌人速度
    SceneManager$1.seekerWalk = 1.1;//追捕者走路的速度参数
    SceneManager$1.seekerRun = 1.3;//追捕者跑步的速度参数
    SceneManager$1.hiderWalk = 1;//躲藏者走路的速度参数
    SceneManager$1.hiderRun = 1.2;//躲藏者跑步的速度参数
    SceneManager$1.playerSeekSpeedMulti = 1;//玩家追捕者的速度加成
    SceneManager$1.monsterSeekSpeedMulti = 1;//怪物追捕者的速度加成
    SceneManager$1.playCanGetDis = 3;//玩家能抓捕的距离（当抓捕者与被抓捕者之间距离小于该值的时候可以抓捕）
    SceneManager$1.monsterCanGetDis = 2.5;//怪物能抓捕的距离（当抓捕者与被抓捕者之间距离小于该值的时候可以抓捕）
    SceneManager$1.rewardBase = 500;  //基础奖励
    SceneManager$1.rewardBox = 200;   //开箱子奖励
    SceneManager$1.canOpenBoxDis = 2; //可以开启箱子的距离
    SceneManager$1.maxStage = 1; //最大关卡，勿修改
    SceneManager$1.timeout = null;
    SceneManager$1.overgame = false;

    SceneManager$1.sourceURL = "https://qygres.17666.mobi/xgmres/nanjing/huawei/";//资源加载地址

    SceneManager$1.UI_MAIN = 1;
    SceneManager$1.UI_GAME = 2;
    SceneManager$1.UI_LOADING = 3;
    SceneManager$1.curScene = -1;
    SceneManager$1.boss = null;
    SceneManager$1.resScene = null;
    SceneManager$1.resModels = null;
    SceneManager$1.player = null;
    SceneManager$1.playerAnimator = null;
    SceneManager$1.camera = null;
    SceneManager$1.monsterList = [];
    SceneManager$1.pause = false;
    SceneManager$1.tempPause = false;
    SceneManager$1.isGamming = false;
    SceneManager$1.gameUI = null;
    SceneManager$1.mainUI = null;
    SceneManager$1.loadingUI = null;
    SceneManager$1.curStage = 1;
    SceneManager$1.rocker = 0.5; //灵敏度
    SceneManager$1.playerPos = [];
    SceneManager$1.objects = [];
    SceneManager$1.itemPos = [];
    SceneManager$1.model = 1;//模式   1躲      2抓
    SceneManager$1.monsterName =
        [
            { name: "Among_1", icon: "shop/j7.png" },
            { name: "Among_2", icon: "shop/j8.png" },
            { name: "Among_3", icon: "shop/j10.png" },
            { name: "Among_4", icon: "shop/j12.png" },
            { name: "Among_5", icon: "shop/j13.png" },
            { name: "Among_6", icon: "shop/j14.png" },
            { name: "Among_7", icon: "shop/j4.png" },
            { name: "Among_8", icon: "shop/j5.png" },
        ];
    SceneManager$1.bossName =
        [
            { name: "Among_1", icon: "shop/j1.png" },
            { name: "Among_2", icon: "shop/j1.png" },
            { name: "Among_3", icon: "shop/j1.png" },
            { name: "Among_4", icon: "shop/j1.png" },
            { name: "Among_5", icon: "shop/j1.png" },
            { name: "Among_6", icon: "shop/j1.png" },
            { name: "Among_7", icon: "shop/j1.png" },
            { name: "Among_8", icon: "shop/j1.png" },
        ];
    SceneManager$1.y_floor1 = 1.7;
    SceneManager$1.y_floor2 = 3.5;


    SceneManager$1.Name1 = [
        "疯狂的",
        "可爱的",
        "完美的",
        "漂亮的",
        "凶猛的",
        "害羞的",
        "勤奋的",
        "可怕的",
        "好玩的",
        "幼稚的",
        "美丽的",
        "矫情的",
    ];
    SceneManager$1.Name2 = [
        "兔宝宝",
        "哈士奇",
        "仓鼠",
        "孩子",
        "熊猫",
        "金丝猴",
        "河马",
        "闪电",
        "加菲猫",
        "巨无霸",
        "披萨饼",
        "老头子",
    ];


    // event1  完成游戏
    // 2       取胜
    // 3       累计搜集宝箱
    // 4       累计抓捕
    // 5       购买皮肤
    SceneManager$1.pauseUI = false;
    SceneManager$1.isGoBackMain = false;

    SceneManager$1.showCP = [0, 0, 0, 0, 0, 0, 0]; //0:商城   1:成就   2:主界面   3:地图选择界面   4:模式界面   5:失败    6：胜利界面

    // import SceneManager from "./SceneManager";
    class script_move {
        static test(obj) {
            if (obj == null)
                return;
            script_move.move(obj, new Laya.Vector3(0, 0, 0));
        }
        // static move(obj, dir) {
        //     if (obj == null)
        //         return false;
        //     let old = new Laya.Vector3(obj.transform.position.x, obj.transform.position.y, obj.transform.position.z);
        //     obj.transform.translate(dir);

        //     let _ray = new Laya.Ray(new Laya.Vector3(obj.transform.position.x, obj.transform.position.y + 100, obj.transform.position.z), new Laya.Vector3(0, -1, 0));
        //     let _outHitInfo = [];
        //     let scene = SceneManager.resScene;
        //     scene.physicsSimulation.rayCastAll(_ray, _outHitInfo);
        //     let ret = null;
        //     if (_outHitInfo.length == 0) {
        //         obj.transform.position = old;
        //         return false;
        //     }
        //     else {
        //         let yy = -100;
        //         for (let i = 0; i < _outHitInfo.length; i++) {
        //             let r = _outHitInfo[i];
        //             if (r.succeeded && r.collider.owner.layer == 2 && r.point.y > yy) {
        //                 ret = r;
        //                 yy = r.point.y;
        //             }
        //             else if (r.collider.owner.layer == 8) {
        //                 ret = null;
        //                 break;
        //             }
        //         }
        //         if (ret) {
        //             obj.transform.position = ret.point;
        //             return true;
        //         }
        //         else {
        //             obj.transform.position = old;
        //             return false;
        //         }
        //     }
        //     return false;
        //     //        Laya.Vector3

        // }
        static free(obj) {
            let controller = obj.getComponent(Laya.CharacterController);
            controller.move(new Laya.Vector3(0, 0, 0));
        }

        //     var xx = 0;
        // var yy = 0;
        // var tha = Math.PI/4;
        // var params = [xx,yy,tha];

        // function changeAngle(param){
        // 	if(param[0] !== 0 && param[1] !== 0){

        // 		var x = param[0];
        // 		var y = param[1];
        // 		var tha1 = param[2];

        // 		var value = Math.sqrt(x*x + y*y);

        // 		var cos1 = x / value;
        // 		var sin1 = y / value;

        // 		var cos2 = Math.cos(tha1);
        // 		var sin2 = Math.sin(tha1);

        // 		var cos3 = cos1*cos2 - sin1*sin2;
        // 		var sin3 = sin1*cos2 + cos1*sin2;
        // 		param[0] = (value * cos3).toFixed(2);
        // 		param[1] = (value * sin3).toFixed(2);
        // 	}
        // }


        // /**
        // * 获取本地前方坐标
        // * @param startPoint 起点位置
        // * @param angle 角度
        // * @param distance 长度 默认值:10
        // * @return 本地坐标系前方坐标
        // */
        // public static GetLocalForward(startPoint:Laya.Vector3,angle:number,distance:number = 10):Laya.Vector3
        // {
        // let localForward:Laya.Vector3 = new Laya.Vector3();
        // let radian =(angle * Math.PI)/180;
        // localForward.x = startPoint.x + distance * Math.sin(radian);
        // localForward.y = startPoint.y;
        // localForward.z = (startPoint.z+distanceMath.cos(radian));
        // return localForward;
        // }

        static move(obj, dir) {
            let localForward = new Laya.Vector3(0, 0, 0);
            let radian = obj.transform.localRotationEulerY * Math.PI / 180;
            Laya.Quaternion.createFromAxisAngle(new Laya.Vector3(0, 1, 0), radian, localForward);
            let pos = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.transformQuat(dir, localForward, pos);
            let controller = obj.getComponent(Laya.CharacterController);
            controller.move(pos);

            return true;
        }
        static jump() {
            SceneManager.playerController.jump();
        }
    }

    class script_player {
        //初始化
        static Init() {
            script_move.test(SceneManager$1.player);
            script_player._timer_animator = 0;   //动作计时
            script_player.Idle(true);
            script_player.finishedTaskNum = 0;
        }

        //移动
        static Move(dirX, dirY) {
            if (script_player._timer_animator > 0)
                return;
            if (script_player._isMove == false) {
                script_player._isMove = true;
                SceneManager$1.PlaySound("run", 0);
            }
            if (script_player._isSquat) {
                script_player.Play("Among_SquatWalk");
            }
            else if (script_player._isRun) {
                script_player.Play("Among_Run");
            }
            else {
                script_player.Play("Among_Walk");
            }

            if (script_player._isSquat) {
                script_player._speed = SceneManager$1.playerSpeed * 0.4;
            }
            // else {
            //     if (SceneManager.model == 1) {//躲藏
            //         script_player._speed = SceneManager.playerSpeed * SceneManager.hiderWalk;
            //     } else {
            //         script_player._speed = SceneManager.playerSpeed * SceneManager.seekerWalk;
            //     }
            // }
            if (script_player._isRun) {
                if (SceneManager$1.model == 1) {//躲藏
                    script_player._speed = SceneManager$1.playerSpeed * SceneManager$1.hiderRun;
                } else {
                    script_player._speed = SceneManager$1.playerSpeed * SceneManager$1.seekerRun;
                }
                // script_player._speed = script_player._speed * SceneManager.seekerRun;
            }
            else {
                if (SceneManager$1.model == 1) {//躲藏
                    script_player._speed = SceneManager$1.playerSpeed * SceneManager$1.hiderWalk;
                } else {
                    script_player._speed = SceneManager$1.playerSpeed * SceneManager$1.seekerWalk;
                }
            }
            let spd = script_player._speed * Laya.timer.delta / 1000;
            if (SceneManager$1.model == 2) {
                spd *= SceneManager$1.playerSeekSpeedMulti;
            }
            script_move.move(SceneManager$1.player, new Laya.Vector3(dirX * spd, 0, dirY * spd));
        }
        static Idle(b) {

            if (script_player._isMove || b) {
                script_player._isMove = false;
                script_move.free(SceneManager$1.player);
                SceneManager$1.StopSound("run");
                if (script_player._isSquat) {
                    console.log("keepsquattttttttttttttttttttttttttt");
                    script_player.Play("Among_KeepSquat");
                }
                else {
                    script_player.Play("Among_Idle");
                }
            }
        }
        //boss攻击
        static Attack() {
            if (script_player._timer_animator > 0)
                return;
            script_player._isMove = false;
            script_move.free(SceneManager$1.player);
            let attackMovieName = "Among_Attack";
            // let randomNum = Math.random() * 3;
            // if (randomNum < 1) {
            console.log("攻击1");
            attackMovieName = "Among_Attack";
            // } else if (randomNum < 2) {
            //     console.log("攻击2")
            //     attackMovieName = "Among_Attack"
            // } else if (randomNum < 3) {
            //     console.log("攻击3")
            //     attackMovieName = "Among_Attack"
            // }
            script_player.Play(attackMovieName, true);

            script_player._timer_animator = 1000;
        }
        static Action() {
            console.log("玩家开箱子");
            if (script_player._isMove) {
                script_move.free(SceneManager$1.player);
                SceneManager$1.StopSound("run");
            }
            script_player._isSquat = false;
            script_player.Play("Among_OpenBox");
        }
        static GetAim() {
            return script_player._bAim;
        }

        static IsAnimator() {
            return script_player._timer_animator > 0;
        }
        static Tick() {
            if (script_player._isDeath)
                return;
            if (SceneManager$1.pause) {
                if (script_player._isMove) {
                    script_player.Idle(true);
                }
                return;
            }

            let dt = Laya.timer.delta;
            if (script_player._isRun) {
                // if (script_player.isvideoRun) {
                // script_player._power = 5000;
                // } else {
                script_player._power -= dt * 2;
                // }
            } else {
                // if (script_player.isvideoRun) {
                // script_player._power = 5000;
                // } else {
                script_player._power += dt;
                // }
            }

            if (script_player._power > script_player._powerMax) {
                script_player._power = script_player._powerMax;
            }
            else if (script_player._power < 0) {
                script_player._power = 0;
                script_player._isRun = false;
            }

            if (script_player._timer_animator > 0) {
                script_player._timer_animator -= dt;
                if (script_player._timer_animator <= 0) {
                    script_player.Idle(true);
                }
                return;
            }
        }
        static Play(anim, b = false) {
            if (script_player._isDeath)
                return;
            if (script_player._curAnim == anim && b == false) {
                return;
            }
            if (b) {
                // SceneManager.playerAnimator.play(anim, 0, false);
                SceneManager$1.playerAnimator.crossFade(anim, 0.15, 0, false);
            }
            else {
                // SceneManager.playerAnimator.play(anim);
                SceneManager$1.playerAnimator.crossFade(anim, 0.15);
            }
            script_player._curAnim = anim;
        }
        static onHit() {
            script_player._isDeath = true;
            script_move.free(SceneManager$1.player);
            SceneManager$1.playerAnimator.play("Among_Fall", 0, false);
        }
        static Run(b) {
            script_player._isRun = b && script_player._power > 100;
        }
        static Jump() {
            console.log("玩家跳");
            if (SceneManager$1.playerController.isGrounded == false) {//不在地表的时候不能再次起跳
                return;
            }
            script_player._timer_animator = 600;
            SceneManager$1.playerController.jump();
            script_player.Play("Among_Jump", true);
        }
        static Squat(b = null) {
            script_player._isRun = false;
            if (b == null) {
                script_player._isSquat = !script_player._isSquat;
            }
            else {
                script_player._isSquat = b;
            }
            if (script_player._isMove) {
                if (script_player._isSquat)
                    SceneManager$1.playerAnimator.play("Among_SquatWalk", 0, false);
                else
                    SceneManager$1.playerAnimator.play("Among_Run", 0, false);
            }
            else {
                if (script_player._isSquat)
                    SceneManager$1.playerAnimator.play("Among_Squat", 0, false);
                else {
                    SceneManager$1.playerAnimator.play("Among_Idle", 0, false);
                }
            }
        }
        static IsSquat() {
            return script_player._isSquat;
        }
        static initPlayer() {
            script_player._isMove = false;
            script_player._isSquat = false; //是否蹲下
            script_player._isRun = false; // 是否跑动
            script_player._isDeath = false;
        }
    }
    script_player._isDeath = false;
    script_player._speed = 4;
    script_player._isMove = false;
    script_player._isSquat = false; //是否蹲下
    script_player._isRun = false; // 是否跑动
    script_player._curAnim = "";
    script_player._power = 5000;
    script_player._powerMax = 5000;
    script_player.runvideo = false;
    // script_player.isvideoRun = false;

    class CameraMoveScript extends Laya.Script3D {
    	constructor() {
    		super();
    		this._tempVector3 = new Laya.Vector3();
    		this.lastMouseX = 0;
    		this.lastMouseY = 0;
    		this.yawPitchRollCamera = new Laya.Vector3();
    		this.yawPitchRollPlayer = new Laya.Vector3();
    		this.resultRotation = new Laya.Quaternion();
    		this.tempRotationZ = new Laya.Quaternion();
    		this.tempRotationX = new Laya.Quaternion();
    		this.tempRotationY = new Laya.Quaternion();
    		this.isMouseDown = false;
    		this.rotaionSpeed = 0.0002 * SceneManager$1.rocker;
    		this.player = SceneManager$1.player;
    		this.speed = 0.02;

    		this.respireX = 1; //呼吸效果
    		this.respireY = 1; //呼吸效果
    		this.respire = 1;// 呼吸效果系数
    		this.respireX_cur = 0; //呼吸效果
    		this.respireY_cur = 0; //呼吸效果
    		this.recoil_max = 0; //后坐力修正
    		this._resetRespireEffect();
    	}
    	//重置呼吸效果
    	_resetRespireEffect() {
    		this.respireX = ((SceneManager$1.RandomInt(15, 20) - 10) / 1000) * (SceneManager$1.RandomInt(1, 10) > 5 ? 1 : -1);
    		this.respireY = SceneManager$1.RandomInt(10, 15) / 1000 * this.respire;
    		this.respire *= -1;
    		this.respireX_cur = 0;
    		this.respireY_cur = 0;
    	}//呼吸效果
    	update_respire() {
    		let offsetX = (0.0001 * (this.respireX > 0 ? 1 : -1));
    		let offsetY = (0.0001 * (this.respireY > 0 ? 1 : -1));
    		this.respireX_cur += offsetX;
    		this.respireY_cur += offsetY;

    		if (offsetX != 0) {
    			var yprElem = this.yawPitchRollPlayer;
    			yprElem.x -= offsetX;
    			this._updateRotationX();
    		}
    		if (offsetY != 0) {
    			var yprElem = this.yawPitchRollCamera;
    			yprElem.y -= offsetY;
    			if (this.recoil_max > 0) {
    				let v = this.recoil_max / 5;
    				yprElem.y += v;
    				this.recoil_max -= v;
    			}

    			if (yprElem.y < -0.8) {
    				yprElem.y = -0.8;
    			}
    			this._updateRotationY();
    		}

    		if (Math.abs(this.respireX_cur) > Math.abs(this.respireX) && Math.abs(this.respireY_cur) > Math.abs(this.respireY)) {
    			this._resetRespireEffect();
    		}
    	}
    	/**
    	  * @private
    	  */
    	_updateRotationX() {
    		let tmp1 = new Laya.Quaternion();
    		Laya.Quaternion.createFromYawPitchRoll(this.yawPitchRollPlayer.x, 0, 0, tmp1);

    		tmp1.cloneTo(this.player.transform.localRotation);
    		this.player.transform.localRotation = this.player.transform.localRotation;

    		// console.log("this.yawPitchRollPlayer.x:" + this.yawPitchRollPlayer.x);


    	}
    	initRotation(v) {
    		this.yawPitchRollPlayer.x = v / 180 * Math.PI;
    	}
    	_updateRotationY() {
    		let tmp2 = new Laya.Quaternion();
    		Laya.Quaternion.createFromYawPitchRoll(this.yawPitchRollCamera.x, this.yawPitchRollCamera.y, 0, tmp2);
    		tmp2.cloneTo(this.owner.transform.localRotation);
    		this.owner.transform.localRotation = this.owner.transform.localRotation;
    	}
    	onRecoil(v) {
    		var yprElem = this.yawPitchRollCamera;
    		if (yprElem.y > -0.6) {
    			yprElem.y -= 0.02;
    			this._updateRotationY();
    			this.recoil_max += 0.015;
    		}
    	}


    	// 	/**
    	// 	 * @inheritDoc
    	// 	 */
    	/*override*/
    	onAwake() {

    		SceneManager$1.gameUI._rightBox.on(Laya.Event.MOUSE_DOWN, this, this.mouseDown);
    		SceneManager$1.gameUI._rightBox.on(Laya.Event.MOUSE_UP, this, this.mouseUp);

    		Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
    		// Laya.stage.on(Event.RIGHT_MOUSE_OUT, this, mouseOut);
    	}
    	onKeyDown(e) {
    		switch (e.keyCode) {
    			case 87: // up
    				script_player.Move(0, 1);
    				break;
    			case 83: // down
    				script_player.Move(0, -1);
    				break;
    			case 65: //left
    				script_player.Move(1, 0);
    				break;
    			case 68://right
    				script_player.Move(-1, 0);
    				break;
    			default:
    				return;
    		}
    	}
    	/**
    	  * @inheritDoc
    	  */
    	/*override*/
    	onUpdate() {
    		// var elapsedTime = Laya.timer.delta;
    		// if (!isNaN(this.lastMouseX) && !isNaN(this.lastMouseY) && this.isMouseDown) {
    		// 	var scene = SceneManager.resScene;
    		// 	// KeyBoardManager.hasKeyDown(87) && this.moveForward(-this.speed * elapsedTime);//W
    		// 	// KeyBoardManager.hasKeyDown(83) && this.moveForward(this.speed * elapsedTime);//S
    		// 	// KeyBoardManager.hasKeyDown(65) && this.moveRight(-this.speed * elapsedTime);//A
    		// 	// KeyBoardManager.hasKeyDown(68) && this.moveRight(this.speed * elapsedTime);//D
    		// 	// KeyBoardManager.hasKeyDown(81) && this.moveVertical(this.speed * elapsedTime);//Q
    		// 	// KeyBoardManager.hasKeyDown(69) && this.moveVertical(-this.speed * elapsedTime);//E

    		// 	var offsetX = Laya.stage.mouseX - this.lastMouseX;
    		// 	var offsetY = this.lastMouseY - Laya.stage.mouseY;

    		// 	// offsetX += this.respireX_cur;
    		// 	// offsetY += this.respireY_cur;
    		// 	if (offsetX != 0) {
    		// 		var yprElem = this.yawPitchRollPlayer;
    		// 		yprElem.x -= offsetX * this.rotaionSpeed * elapsedTime;
    		// 		this._updateRotationX();
    		// 	}
    		// 	if (offsetY != 0) {
    		// 		var yprElem = this.yawPitchRollCamera;
    		// 		yprElem.y -= offsetY * this.rotaionSpeed * elapsedTime;
    		// 		if (yprElem.y < -0.8) {
    		// 			yprElem.y = -0.8;
    		// 		}
    		// 		this._updateRotationY();
    		// 	}


    		// }
    		// this.lastMouseX = Laya.stage.mouseX;
    		// this.lastMouseY = Laya.stage.mouseY;
    		//this.update_respire();
    		// {

    		// 	let eulerAngle = this.player.transform.localRotationEulerY;
    		// 	console.log("四元数转欧拉角：" + eulerAngle);//输出：(352.3, 47.7, 70.3)
    		// }

    		// console.log("x:" + this.player.transform.rotation.x + "y:" + this.player.transform.rotation.y + " z:" + this.player.transform.rotation.z);
    	}
    	// move() {
    	// 	SceneManager.model.transform.localRotation = new Laya.Vector3(0, -this.camera.transform.localRotation.y, 0);
    	// }

    	/**
    	  * @inheritDoc
    	  */
    	/*override*/
    	onDestroy() {
    		// SceneManager.gameUI._rightBox.off(Event.RIGHT_MOUSE_DOWN, this, this.mouseDown);
    		// SceneManager.gameUI._rightBox.off(Event.RIGHT_MOUSE_UP, this, this.mouseUp);
    		//Laya.stage.off(Event.RIGHT_MOUSE_OUT, this, mouseOut);
    	}
    	mouseMove(e) {
    		// if (e.touchId != this.touchId)
    		// 	return;
    		// console.log("X:" + e.stageX + " Y:" + e.stageY);
    		this.tick(e.stageX, e.stageY);
    	}
    	tick(x, y) {
    		// this.setPosition();
    		this.rotaionSpeed = 0.0002 * SceneManager$1.rocker;
    		var elapsedTime = Laya.timer.delta;
    		var scene = SceneManager$1.resScene;

    		var offsetX = x - this.lastMouseX;
    		var offsetY = y - this.lastMouseY;

    		if (offsetX != 0) {
    			var yprElem = this.yawPitchRollPlayer;
    			yprElem.x -= offsetX * this.rotaionSpeed * elapsedTime;
    			this._updateRotationX();
    		}
    		// if (offsetY != 0) {
    		// 	var yprElem = this.yawPitchRollCamera;
    		// 	yprElem.y -= offsetY * this.rotaionSpeed * elapsedTime;

    		// 	console.log("yyyy:" + yprElem.y);
    		// 	this._updateRotationY();
    		// }


    		this.lastMouseX = x;
    		this.lastMouseY = y;
    		// this.update_respire();
    	}
    	mouseDown(e) {

    		SceneManager$1.gameUI._rightBox.on(Laya.Event.MOUSE_MOVE, this, this.mouseMove);
    		this.touchId = e.touchId;
    		//SceneManager.gameUI._rightBox.on(Laya.Event.MOUSE_UP, this, this.mouseUp);

    		this.owner.transform.localRotation.getYawPitchRoll(this.yawPitchRollCamera);
    		this.player.transform.localRotation.getYawPitchRoll(this.yawPitchRollPlayer);

    		this.lastMouseX = e.stageX;
    		this.lastMouseY = e.stageY;
    		// this.isMouseDown = true;
    	}

    	mouseUp() {
    		this.isMouseDown = false;
    		this.touchId = -1;
    		SceneManager$1.gameUI._rightBox.off(Laya.Event.MOUSE_MOVE, this, this.mouseMove);
    	}

    	// protected mouseOut(e: Event): void {
    	// 	this.isMouseDown = false;
    	// }

    	/**
    	 * 向前移动。
    	 * @param distance 移动距离。
    	 */
    	moveForward(distance) {
    		this._tempVector3.x = this._tempVector3.y = 0;
    		this._tempVector3.z = distance;
    		this.camera.transform.translate(this._tempVector3);
    	}

    	/**
    	 * 向右移动。
    	 * @param distance 移动距离。
    	 */
    	moveRight(distance) {
    		this._tempVector3.y = this._tempVector3.z = 0;
    		this._tempVector3.x = distance;
    		this.camera.transform.translate(this._tempVector3);
    	}

    	/**
    	 * 向上移动。
    	 * @param distance 移动距离。
    	 */
    	moveVertical(distance) {
    		this._tempVector3.x = this._tempVector3.z = 0;
    		this._tempVector3.y = distance;
    		this.camera.transform.translate(this._tempVector3, false);
    	}

    }

    class script_monster extends Laya.Script3D {
        init(isBoss, id) {
            this.finishedTaskNum = 0;//抓人或者开箱子的数量

            this.namestr = SceneManager$1.RandomName();
            if (isBoss) {
                SceneManager$1.gameUI.bossName = this.namestr;
            }
            this._name = new Laya.Label(this.namestr);
            this._name.fontSize = 30;
            SceneManager$1.gameUI.addName(this._name);
            this._name.color = (isBoss || SceneManager$1.model == 2) ? "#ff2b03" : "#ffffff";
            this.monsterid = id;
            this.isBoss = isBoss;
            this.controller = this.owner.addComponent(Laya.CharacterController);
            let sphereShape = new Laya.CapsuleColliderShape(1, 1.8);
            // sphereShape.localOffset = new Laya.Vector3(0, 0, 0.4);
            this.controller.colliderShape = sphereShape;
            this.controller.stepHeight = 0.3;
            this.owner.transform.localRotation = this.owner.transform.localRotation;
            this.owner.name = this.isBoss ? "boss" : "player";
            //随机点

            let n = SceneManager$1.RandomInt(0, SceneManager$1.playerPos.length - 1);
            this.owner.transform.position = SceneManager$1.playerPos[n];
            this.lastPlayerPos = [];
            this.animator = this.owner.getComponent(Laya.Animator);
            this.speed = 1 / 1000;
            this.timer = 0;    //记录丧失目标的timer
            this.Alert = 0;
            this.active = true;
            this.bfind = false; //是否被发现
            this.stop = false; //是否移动中
            this.pathLog = [];
            this.setRun(false);


            // if (this.isBoss == true) {//模式 1 ai抓 2 ai躲
            //     this.setRun(false);
            // }
            // else {
            //     this.setRun(true);
            // }

        }
        setRun(b) {
            if (this.isRun == b && this.stop == false)
                return;
            this.stop = false;
            // this.speed = SceneManager.monsterSpeed / 1000 * (b ? 1 : 0.6);
            if (SceneManager$1.model == 1) {//躲藏
                if (this.isBoss) {
                    if (b) {
                        this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.seekerRun;
                    } else {
                        this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.seekerWalk;
                    }
                } else {
                    if (b) {
                        this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.hiderRun;
                    } else {
                        this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.hiderWalk;
                    }
                }
            } else {//追捕模式（怪物全部都是躲藏）
                if (b) {
                    this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.hiderRun;
                } else {
                    this.speed = SceneManager$1.monsterSpeed / 1000 * SceneManager$1.hiderWalk;
                }
            }
            if (SceneManager$1.model == 1 && this.isBoss) {//选择的模式为躲藏模式且当前monster为boss（追捕者）
                this.speed *= SceneManager$1.monsterSeekSpeedMulti;
            }
            this.animator.play(b ? "Among_Run" : "Among_Walk");
            this.isRun = b;
        }
        stopMove(b = true) {
            this.stop = b;
            if (b)
                this.timer = 0;
            script_move.free(this.owner);
        }

        // move() {
        //     if (this.targetPos == null) {
        //         console.log("error" + this.posIndex + " area：" + this.areaIndex);
        //         return 0;
        //     }
        //     this.lookAt(this.targetPos);
        //     let dt = Laya.timer.delta;
        //     this.curspeed = this.speed * dt;
        //     script_move.move(this.owner, new Laya.Vector3(0, 0, this.curspeed));
        //     let ppos = this.selfPos();
        //     let spos = this.targetPos.clone();
        //     ppos.y = 0;
        //     spos.y = 0;
        //     return Laya.Vector3.distance(ppos, spos);
        // }


        IsInView() {//TODO      没看明白
            var target = SceneManager$1.player;
            // //计算角度
            let y = this.owner.transform.position.z - target.transform.position.z;
            let x = target.transform.position.x - this.owner.transform.position.x;
            let a = Math.atan2(y, x) * 180 / Math.PI;
            let b = target.transform.localRotationEulerY + 90;

            var c = a - b;
            if (c < 0)
                c += 360;
            var d = Math.abs(c - 180);
            return d > 90;
        }

        update() {
            if (this.status == -1 && this.owner.active == false) {//死亡且已经消失后不再做判断（性能优化）
                return;
            }
            this.updateName();
            if (SceneManager$1.pause) {
                this.stopMove(false);
                return;
            }
            if (Laya.timer.delta > 200)
                return;
            this.timer += Laya.timer.delta;
            if (this.targetPos == null)
                this.change_ai();

            if (this.isBoss) {
                this.update_seek();
            }
            else {
                this.update_hide();
            }
        }

        updateName() {
            if (false == this.IsInView() || this.status == -1) {
                this._name.visible = false;
                return;
            }
            // this._name.visible = true;
            this._name.visible = this.canSeePlayer();

            // if (this._name.visible) {
            var camera = SceneManager$1.camera;
            var pos = new Laya.Vector3(0, 0, 0);
            var spos = this.selfPos();
            spos.y += 2;
            camera.viewport.project(spos, camera.projectionViewMatrix, pos);

            var dis = Laya.Vector3.distance(SceneManager$1.player.transform.position, this.owner.transform.position);
            var scale = (30 - dis) / 30;
            if (scale < 0.2)
                scale = 0.2;
            this._name.scaleX = this._name.scaleY = scale;

            this._name.pos(pos.x / Laya.stage.clientScaleX - (this._name.displayWidth / 2), pos.y / Laya.stage.clientScaleY);
            // }
        }

        canSeePlayer() {
            // let playerPos = this.playerPos();
            // let curPos = this.selfPos();
            // let hitResult = new Laya.HitResult();// Laya.HitResult();
            // let ray = new Laya.Ray(curPos, playerPos);
            // SceneManager.resScene.physicsSimulation.rayCast(ray, hitResult);
            // console.debug("TT       ", hitResult.succeeded);
            // if (hitResult.collider) {
            //     console.debug("TT       ", hitResult.collider.owner.name);
            // }
            // if (hitResult.succeeded && hitResult.collider && hitResult.collider.owner.name == "player") {
            //     return true;
            // }
            // return false;

            var dis = 0.2;
            let startPos = SceneManager$1.player.transform.position.clone();
            // let startPos = SceneManager.camera.transform.position.clone();
            // startPos.x = SceneManager.player.transform.position.x;
            // startPos.z = SceneManager.player.transform.position.z;
            startPos.y += dis;
            // startPos.y = SceneManager.camera.transform.position.y;
            // console.log("MM     ", startPos.y, SceneManager.camera.transform.position.y);

            let targetPos = this.owner.transform.position.clone();
            targetPos.y += dis;

            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(startPos, targetPos, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);
            let _ray = new Laya.Ray(targetPos, dst);
            let _outHitInfo = new Laya.HitResult();
            let scene = SceneManager$1.resScene;
            scene.physicsSimulation.rayCast(_ray, _outHitInfo);

            if (_outHitInfo.succeeded == false) {
                return false;
            }
            if ((_outHitInfo.collider && _outHitInfo.collider.owner.name == "monster") ||
                (_outHitInfo.collider && _outHitInfo.collider.owner.name == "player")) {
                return true;
            }
            return false;
        }

        playerPos() {
            return SceneManager$1.boss.transform.position.clone();
        }
        selfPos() {
            return this.owner.transform.position.clone();
        }


        findBox() {
            let boxList = SceneManager$1.gameUI.boxList;
            if (boxList == null)
                return false;
            for (let i = 0; i < boxList.length; i++) {
                let box = boxList[i];
                if (box.name != "box")
                    continue;

                let toPos = box.transform.position.clone();
                let fromPos = this.selfPos();
                if (toPos.y - fromPos.y > 0.5)
                    continue;

                let distance = Laya.Vector3.distance(fromPos, toPos);
                let tmp = new Laya.Vector3(0, 0, 0);
                Laya.Vector3.subtract(toPos, fromPos, tmp);
                let dst = new Laya.Vector3(0, 0, 0);
                Laya.Vector3.normalize(tmp, dst);
                let _ray = new Laya.Ray(fromPos, dst);

                let _outHitInfo = new Laya.HitResult();
                let scene = SceneManager$1.resScene;
                scene.physicsSimulation.rayCast(_ray, _outHitInfo);
                if (_outHitInfo.succeeded == false) {
                    continue;
                }
                if (_outHitInfo.collider.owner.name != "box")
                    continue;
                this.box = box;
                return true;
            }
            this.box = null;
            return false;
        }
        // findKeyPos() {
        //     return false;
        //     var spos = this.selfPos();
        //     let path = [];
        //     let n = 0;
        //     for (var i = 0; i < 4; i++) {
        //         var dir = new Laya.Vector3(0, 0, 0);
        //         if (i < 2) {
        //             dir.z = i == 0 ? 3 : -3;
        //         }
        //         else {
        //             dir.x = i == 2 ? -3 : 3;
        //         }

        //         var target = this.calcTargetPos(dir);
        //         var collider = this.getRay(spos, target);
        //         if (collider.distance < 2 && collider.name != "floor") {
        //             if (spos.y < SceneManager.y_floor2 || collider.name != "air") {
        //                 n++;
        //             }
        //         }
        //     }
        //     return n >= 2;

        // }


        // getNearPoint() {
        //     let selfPos = this.owner.transform.position.clone();
        //     var ret = -1;
        //     var max = 999;
        //     for (var i = 0; i < SceneManager.flagPoint.length; i++) {
        //         if (selfPos.y >= 3 && SceneManager.flagPoint[i].area == "0")
        //             continue;
        //         if (selfPos.y < 2 && SceneManager.flagPoint[i].area != "0")
        //             continue;

        //         var distance = Laya.Vector3.distance(selfPos, SceneManager.flagPoint[i].pos);
        //         if (distance > max)
        //             continue;
        //         ret = SceneManager.flagPoint[i];
        //         max = distance
        //     }
        //     var t = [1, -1, 10, -10, 11, -11, 9, -9];
        //     //八方向
        //     let path = []
        //     for (var i = 0; i < 8; i++) {
        //         var id = parseInt(ret.idx) + t[i];
        //         var pos = this.getPos(id, parseInt(ret.area));
        //         if (pos == null)
        //             continue;
        //         if (this.isCanMove(selfPos, pos)) {
        //             path.push({ 'id': id, 'area': ret.area, 'pos': pos });
        //         }
        //     }
        //     if (path.length <= 1) {
        //         this.showSelfInfo("bbb");
        //         console.log("又是路径错误");
        //     }
        //     var n = 0;
        //     n = SceneManager.RandomInt(0, path.length - 1);
        //     this.posIndex = path[n].id;
        //     this.area = SceneManager.areaList[parseInt(path[n].area)];
        //     this.areaIndex = parseInt(path[n].area);
        //     this.targetPos = path[n].pos;
        //     this.showSelfInfo("设置最近点路标");
        // }
        isCanMove(from, to) { //判断两个点间是否可以通过
            let fromPos = from.clone();
            let toPos = to.clone();

            if (Math.abs(fromPos.y - toPos.y) > 0.5)
                return false;
            // if (toPos.y < fromPos.y) {
            //     toPos.y = fromPos.y;
            // }
            // else {
            //     fromPos.y = toPos.y;
            // }
            // fromPos.y += 0.5;
            // toPos.y += 0.5;

            let distance = Laya.Vector3.distance(fromPos, toPos);
            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(toPos, fromPos, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);
            let _ray = new Laya.Ray(fromPos, dst);

            let _outHitInfo = new Laya.HitResult();
            let scene = SceneManager$1.resScene;
            scene.physicsSimulation.rayCast(_ray, _outHitInfo);
            if (_outHitInfo.succeeded == false) {
                return true;
            }
            let dis = Laya.Vector3.distance(fromPos, _outHitInfo.point);
            if (dis > distance || Math.abs(dis - distance) < 0.5)
                return true;
            return false;
        }


        lookAt(targetPos) {
            let pos = targetPos.clone();
            pos.y = this.owner.transform.position.y;
            this.owner.transform.lookAt(pos, new Laya.Vector3(0, 1, 0));
            this.owner.transform.rotate(new Laya.Vector3(0, 180, 0), false, false);
        }
        //箱子
        onOpenBox() {
            console.log("开启宝箱:" + this.monsterid);
            this.setRun(true);
            this.stop = false;
            if (this.box == null || this.box.name != 'box') {
                console.log("被别人开了");
                return;
            }
            console.log("开启成功" + this.monsterid);

            this.finishedTaskNum++;
            SceneManager$1.gameUI.PickUpItem(this.box, this.namestr);
        }
        onHit() {
            this.status = -1;
            this.stopMove();
            this.animator.play("Among_Fall");
            this.timer = 0;
            this.owner.name = "death";
            SceneManager$1.gameUI.onMonsterDeath(this.namestr);

            this._name.visible = false;
        }
        isDeath() {
            return this.status == -1;
        }

        Attack() {
            console.log("关卡一boss攻击");
            this.stopMove();
            let attackMovieName = "Among_Attack";
            // let randomNum = Math.random() * 3;
            // if (randomNum < 1) {
            attackMovieName = "Among_Attack";
            // } else if (randomNum < 2) {
            //     attackMovieName = "Among_Attack"
            // } else if (randomNum < 3) {
            //     attackMovieName = "Among_Attack"
            // }
            this.animator.play(attackMovieName, 0, false);
            Laya.timer.once(500, this, function () {
                var isOver = SceneManager$1.gameUI.onHitPlayer(this.target);
                if (isOver == false) {
                    this.active = true;
                    this.target = null;
                    this.Alert = 0;
                    this.timer = 0;
                }
            });
        }
        IsBossAI() {
            return this.isBoss;
        }
        findHide() {//找躲藏的人
            if (this.findTarget(SceneManager$1.player)) {
                return SceneManager$1.player;
            }

            for (let i = 0; i < SceneManager$1.gameUI.monster.length; i++) {
                var p = SceneManager$1.gameUI.monster[i];
                if (p.IsBossAI())
                    continue;
                if (this.findTarget(p.owner))
                    return p.owner;
            }
        }
        findTarget(target) {
            let toPos = target.transform.position.clone();
            let fromPos = this.owner.transform.position.clone();
            if (toPos.y - fromPos.y > 0.5)
                return false;

            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(toPos, fromPos, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);
            let _ray = new Laya.Ray(fromPos, dst);

            let _outHitInfo = new Laya.HitResult();
            let scene = SceneManager$1.resScene;
            scene.physicsSimulation.rayCast(_ray, _outHitInfo);

            if (_outHitInfo.succeeded == false) {
                return false;
            }
            if (_outHitInfo.collider.owner.name == "player") {
                //可视距离 最远15
                let distance = Laya.Vector3.distance(target.transform.position, this.owner.transform.position);
                if (this.isBoss == false) {
                    if (this.Alert > 0)
                        return true;
                    else
                        return distance < 12;
                }
                // //计算角度
                let y = target.transform.position.z - this.owner.transform.position.z;
                let x = this.owner.transform.position.x - target.transform.position.x;
                let a = Math.atan2(y, x) * 180 / Math.PI;
                let b = this.owner.transform.localRotationEulerY + 90;
                let c = a - b;
                if (c < 0)
                    c += 360;
                c = c % 180;
                var r = (20 - distance) * 10;
                if (r < 0)
                    r = 0;
                r += 20;
                return c < r;
            }
            return false;
        }

        //空闲，巡逻状态
        update_seek() {
            if (this.active == false)
                return;


            let spos = this.selfPos();
            let b = this.move_ai();
            let distance = Laya.Vector3.distance(spos, this.targetPos);
            this.setRun(this.Alert > 0);
            var target = null;
            if (this.target != null && this.findTarget(this.target)) {
                target = this.target;
            }
            else if (this.target == null) {
                target = this.findHide();
            }

            if (target != null) {  //发现对手，提高警戒值，去跟踪对手路径
                this.target = target;
                let ppos = this.target.transform.position.clone();
                this.lookAt(ppos);
                let dis = Laya.Vector3.distance(spos, ppos);
                if (dis < SceneManager$1.monsterCanGetDis) {
                    this.finishedTaskNum++;
                    this.Attack();
                    this.active = false;
                    return;
                }
                this.targetPos = ppos;
                this.Alert = 1000 * 3;
                this.lastPlayerPos = [this.targetPos];
            }
            else if (this.Alert > 0) {
                this.Alert -= Laya.timer.delta;
                let ppos = this.target.transform.position.clone();
                if (this.Alert > 0) {
                    this.lastPlayerPos.push(ppos);
                    if (distance < 0.1) {
                        this.targetPos = this.lastPlayerPos.pop();
                    }
                }
            }
            else {
                this.target = null;
                // this.timer += Laya.timer.delta;
                if (this.timer > 1000) {
                    this.timer = 0;
                    if (SceneManager$1.RandomInt(0, 100) > 90)
                        this.change_ai_seek();
                }
                else if (b == false) {
                    this.change_ai_seek();
                }
            }
        }
        update_hide() {
            if (this.status == -1) {//死亡，3秒后消失
                if (this.timer > 3000) {
                    this.owner.active = false;
                }
                return;
            }

            if (this.bfind && this.Alert > 0) {//已经被发现且加速时间存在
                this.Alert -= Laya.timer.delta;
                if (this.Alert <= 0) {
                    this.resetTime = 3000;
                    this.setRun(false);
                }
                this.move_ai();
            } else if (this.resetTime > 0) {//加速恢复期
                this.resetTime -= Laya.timer.delta;
                this.move_ai();
            } else {
                let bFind = this.findTarget(SceneManager$1.boss);
                if (bFind) {
                    this.setRun(true);
                    this.Alert = 3000;
                    if (this.bfind == false) {
                        this.change_hide();
                    }
                    var b = this.move_ai();
                    if (this.timer > 3000 || b == false) {
                        if (this.change_hide() == false) {
                            this.stopMove();
                            this.animator.play("Among_KeepSquat");
                        } else {
                            if (this.stop == true) {
                                this.setRun(true);
                            }
                        }
                    }
                    this.bfind = true;
                } else {
                    this.bfind = false;
                    if (this.Alert > 0) {
                        this.Alert -= Laya.timer.delta;
                        if (this.stop == true) {
                            this.Alert = 0;
                        } else {
                            if (this.move_ai() == false) {
                                this.stopMove();
                                this.animator.play("Among_KeepSquat");
                            } else if (this.timer > 2000) {
                                this.change_hide();
                            }
                        }
                    } else {
                        var bBox = this.findBox();
                        // var bHide = this.findKeyPos();
                        var b = this.move_ai();
                        if (this.stop == false) {
                            if (this.box) {
                                this.setRun(true);
                                this.targetPos = this.box.transform.position.clone();
                                this.lookAt(this.targetPos);
                                var disBox = Laya.Vector3.distance(this.selfPos(), this.targetPos);
                                var date = new Date("disBox:" + disBox);
                                console.log();
                                if (disBox < SceneManager$1.canOpenBoxDis) {
                                    this.timer = 0;
                                    this.stopMove();
                                    this.animator.play("Among_OpenBox");
                                }
                            }
                            // else if (bHide) {
                            //     this.stopMove();
                            //     this.animator.play("Among_KeepSquat")
                            // } 
                            else if (b == false) {
                                this.setRun(false);
                                this.change_ai();
                            }
                        } else {//静止中
                            if (this.box != null && this.timer > 5000) {
                                this.onOpenBox();
                            } else if (this.box == null) {
                                this.setRun(false);
                                this.change_ai();
                            }
                        }
                    }
                }
            }
            return;
        }

        IsInPathLog(targetpos) {
            for (var i = 0; i < this.pathLog.length; i++) {
                var pos = this.pathLog[i];
                if (1 > Laya.Vector3.distance(pos, targetpos))
                    return true;
            }
            return false;
        }
        pushPath(pos) {
            this.pathLog.push(pos);
            if (this.pathLog.length > 3) {
                this.pathLog.shift();
            }
        }
        change_ai_seek() {//切换目标点
            this.stop == false;
            this.timer = 0;
            if (this.dir == null) {
                this.dir = new Laya.Vector3(0, 0, 0);
            }
            var temp = null;
            var ret = null;
            var spos = this.selfPos();
            var max = -100;

            let path = null;
            for (var i = 0; i < 9; i++) {
                var dir = new Laya.Vector3(0, 0, 0);
                dir.z = i % 3 - 1;
                dir.x = Math.floor(i / 3) - 1;
                if (dir.z == 0 && dir.x == 0)
                    continue;

                var target = this.calcTargetPos(dir);
                var dis = this.getRay(spos, target).distance;
                var b = this.IsInPathLog(target);
                if (b) {
                    dis -= 10;
                }
                if (dis > max) {
                    path = { target: target, dir: dir };
                    max = dis;
                }
            }
            if (path == null) {
                console.log("seek far卡住了，准备八方向");
                return;
            }
            this.dir = path.dir;
            this.targetPos = path.target;
            this.lookAt(this.targetPos);
            this.pushPath(path.target);
        }

        change_ai() {//切换目标点
            this.stop == false;
            this.timer = 0;
            if (this.dir == null) {
                this.dir = new Laya.Vector3(0, 0, 0);
            }
            var temp = null;
            var ret = null;
            var spos = this.selfPos();
            var max = 0;
            let path = [];
            // for (var i = 0; i < 4; i++) {
            //     var dir = new Laya.Vector3(0, 0, 0);
            //     if (i < 2) {
            //         dir.z = i == 0 ? 3 : -3;
            //     }
            //     else {
            //         dir.x = i == 2 ? -3 : 3;
            //     }
            //     var target = this.calcTargetPos(dir);
            //     var dis = this.getRay(spos, target).distance;
            //     if (dis > 2) {
            //         path.push({ target: target, dir: dir });
            //     }
            // }
            for (var i = 0; i < 9; i++) {
                var dir = new Laya.Vector3(0, 0, 0);
                dir.z = i % 3 - 1;
                dir.x = Math.floor(i / 3) - 1;
                if (dir.z == 0 && dir.x == 0)
                    continue;

                var target = this.calcTargetPos(dir);
                var dis = this.getRay(spos, target).distance;
                if (dis > 2) {
                    path.push({ target: target, dir: dir });
                }
            }
            if (path.length == 0) {
                console.log("卡住了，准备八方向");
                return;
            }
            let n = SceneManager$1.RandomInt(0, path.length - 1);
            this.dir = path[n].dir;
            this.targetPos = path[n].target;
            this.lookAt(this.targetPos);
        }

        // getNewTargetList() {
        //     let path = [];
        //     for (var i = 0; i < 4; i++) {
        //         var dir = new Laya.Vector3(0, 0, 0);
        //         if (i < 2) {
        //             dir.z = i == 0 ? 3 : -3;
        //         }
        //         else {
        //             dir.x = i == 2 ? -3 : 3;
        //         }
        //         var target = this.calcTargetPos(dir);
        //         var dis = this.getRay(spos, target).distance;
        //         if (dis > 2) {
        //             path.push({ target: target, dir: dir });
        //         }
        //     }

        //     let path = null;
        //     for (var i = 0; i < 9; i++) {
        //         var dir = new Laya.Vector3(0, 0, 0);
        //         dir.z = i % 3 - 1;
        //         dir.x = Math.floor(i / 3) - 1;
        //         if (dir.z == 0 && dir.x == 0)
        //             continue;

        //         var target = this.calcTargetPos(dir);
        //         var dis = this.getRay(spos, target).distance;
        //         var b = this.IsInPathLog(target);
        //         if (b) {
        //             dis -= 10;
        //         }
        //         if (dis > max) {
        //             path = { target: target, dir: dir };
        //             max = dis;
        //         }
        //     }
        // }

        change_hide() {//逃跑
            this.stop == false;
            this.timer = 0;
            if (this.dir == null) {
                this.dir = new Laya.Vector3(0, 0, 0);
            }
            var temp = null;
            var ret = null;
            var spos = this.selfPos();
            var ppos = this.playerPos();
            var max = -100;
            let path = [];
            for (var i = 0; i < 4; i++) {
                var dir = new Laya.Vector3(0, 0, 0);
                if (i < 2) {
                    dir.z = i == 0 ? 3 : -3;
                }
                else {
                    dir.x = i == 2 ? -3 : 3;
                }

                var target = this.calcTargetPos(dir);

                var disa = Laya.Vector3.distance(spos, target);
                var disb = Laya.Vector3.distance(ppos, target);
                var disc = disb - disa;
                if (disb < (disa * 0.9))
                    continue;
                var dis = this.getRay(spos, target).distance;
                if (dis > 2) {
                    max = disc;
                    path.push({ target: target, dir: dir });
                }
            }
            if (path.length == 0) {
                for (var i = 0; i < 4; i++) {
                    var dir = new Laya.Vector3(0, 0, 0);
                    dir.z = i % 2 == 0 ? 3 : -3;
                    dir.z = i < 2 ? -3 : 3;

                    var target = this.calcTargetPos(dir);

                    var disa = Laya.Vector3.distance(spos, target);
                    var disb = Laya.Vector3.distance(ppos, target);
                    var disc = disb - disa;
                    if (disb < (disa * 0.9))
                        continue;
                    var dis = this.getRay(spos, target).distance;
                    if (dis > 2) {
                        max = disc;
                        path.push({ target: target, dir: dir });
                    }
                }
            }
            if (path.length == 0)
                return false;
            let n = SceneManager$1.RandomInt(0, path.length - 1);
            this.dir = path[n].dir;
            this.targetPos = path[n].target;
            this.lookAt(this.targetPos);
            return true;
            // console.log("最终结果" + max + " 目标点x:" + temp.x + " z:" + temp.z + " selfX:" + spos.x + " selfZ:" + spos.z);
        }


        calcTargetPos(dir) {
            let ppos = this.selfPos();
            let localForward = new Laya.Vector3(0, 0, 0);
            let radian = this.owner.transform.localRotationEulerY * Math.PI / 180;
            Laya.Quaternion.createFromAxisAngle(new Laya.Vector3(0, 1, 0), radian, localForward);
            let pos = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.transformQuat(dir, localForward, pos);
            let ret = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.add(ppos, pos, ret);
            return ret;
        }
        move_ai() {
            if (this.stop == true)
                return false;
            if (this.dir == null) {
                this.change_ai();
                return true;
            }
            let dt = Laya.timer.delta;
            this.curspeed = this.speed * dt;

            script_move.move(this.owner, new Laya.Vector3(0, 0, this.curspeed));
            return this.canForce();
        }
        canForce() {
            var spos = this.selfPos();
            var dir = new Laya.Vector3(0, 0, 1);
            var target = this.calcTargetPos(dir);
            var dis = this.getRay(spos, target).distance;

            var disb = Laya.Vector3.distance(spos, target);
            return disb < dis;

        }
        getRay(fromPos, toPos) {
            // fromPos.y += 1;
            // toPos.y += 1;
            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(toPos, fromPos, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);
            let _ray = new Laya.Ray(fromPos, dst);

            let _outHitInfo = new Laya.HitResult();
            let scene = SceneManager$1.resScene;
            scene.physicsSimulation.rayCast(_ray, _outHitInfo);

            if (_outHitInfo.succeeded == false) {
                return { distance: 10, name: "name" };
            }
            else if (_outHitInfo.collider.owner.name == "floor") {
                // console.log("跳过楼梯");
                return { distance: 10, name: "floor" };
            }
            return { distance: Laya.Vector3.distance(fromPos, _outHitInfo.point), name: _outHitInfo.collider.owner.name };
        }
    }

    class DataManager {
        static Init(callback) {
            DataManager.InitPlayerData();
            DataManager.InitTableData();
        }
        static InitTableData() {
            var config = [
                "res/jsondata/shop.json",
                "res/jsondata/boss.json",
                "res/jsondata/stage.json",
                "res/jsondata/achievment.json",
            ];
            Laya.loader.load(config, Laya.Handler.create(this, function () {
                DataManager.shop = Laya.loader.getRes(config[0]); //
                console.log("WW     ", DataManager.shop);
                DataManager.monster = Laya.loader.getRes(config[1]); //
                DataManager.stage = Laya.loader.getRes(config[2]); //
                DataManager.achievment = Laya.loader.getRes(config[3]); //
                SceneManager$1.maxStage = 0;
                for (var key in DataManager.stage) {
                    DataManager.stage[key]["boss"] = DataManager.formatData(DataManager.stage[key]["boss"]);
                    DataManager.stage[key]["item"] = DataManager.formatData(DataManager.stage[key]["item"]);
                }
                for (var key in DataManager.monster) {
                    DataManager.monster[key]['Path'] = DataManager.formatData(DataManager.monster[key]['Path']);
                }


                if (DataManager.UserData["Sound"] == 1) {
                    SceneManager$1.OpenSound();
                }
                else {
                    SceneManager$1.CloseSound();
                }
                let volume = DataManager.UserData["Volume"];
                SceneManager$1.SetVolume(volume);
                let rocker = DataManager.UserData["Rocker"];
                SceneManager$1.SetRocker(rocker);
                console.log("DataManager    InitTableData   数据资源加载完成");
                SceneManager$1.loadingUI.onDataInit();
            }));
        }
        static formatData2(data) {
            let b = data.indexOf("|");
            let obj = [];

            if (b > 0) {//二维数组
                var ary = data.split("|");
                for (let i = 0; i < ary.length; i++) {
                    let ary2 = ary[i].split(",");
                    let o = [];
                    for (let j = 0; j < ary2.length; j++) {
                        o.push(ary2[j]);
                    }
                    obj.push(o);
                }
            }
            else {//一维数组
                var ary = data.split(',');
                obj.push(ary);
            }
            return obj;

        }
        static formatData(data) {
            // let b = data.indexOf("|");
            // let obj = []

            // if (b > 0) {//二维数组
            //     var ary = data.split("|");
            //     for (let i = 0; i < ary.length; i++) {
            //         let ary2 = ary[i].split(",");
            //         let o = []
            //         for (let j = 0; j < ary2.length; j++) {
            //             o.push(ary2[j]);
            //         }
            //         obj.push(o);
            //     }

            //     return obj;
            // }
            // else {//一维数组
            var ary = data.split('|');
            return ary;
            // }

        }
        static InitPlayerData() {
            let newDay = false;
            var s = Laya.LocalStorage.getItem("userData" + DataManager.version);
            if (s) {
                DataManager.UserData = JSON.parse(s);
                var day = new Date().getDate();
                //新的一天
                if (DataManager.UserData.curDay != day) {
                    DataManager.UserData.curDay = day;
                    newDay = true;
                }
            }

            {//根据模板检测data
                for (var key in DataManager.template) {
                    if (DataManager.UserData[key] && DataManager.template[key]["day"] == false) {
                        continue;
                    }
                    DataManager.UserData[key] = DataManager.template[key].default;
                }
            }
            Laya.timer.loop(500, this, DataManager._saveTick);
        }
        static _saveTick() {
            if (DataManager._dirty == false)
                return;
            DataManager._saveData();
            DataManager._dirty = false;
        }

        static _saveData() {
            var data = JSON.stringify(DataManager.UserData);
            Laya.LocalStorage.setItem("userData" + DataManager.version, data);
        }

        static GetData(key) {
            if (DataManager.UserData[key] != null)
                return DataManager.UserData[key];
            return null;
        }
        static SetData(key, val) {
            DataManager.UserData[key] = val;
            DataManager._dirty = true;
        }
        static AddMoney(val) {
            if (val <= 0)
                return;
            DataManager.SetData("Money", DataManager.UserData["Money"] + val);
            SceneManager$1.ShowMoneyAdd(val);
            if (SceneManager$1.mainUI) {
                SceneManager$1.mainUI.UpdateMoney();
            }
        }
        static DelMoney(val) {
            if (val <= 0)
                return true;
            let cur = DataManager.UserData["Money"];
            if (cur < val)
                return false;
            cur -= val;
            DataManager.SetData("Money", cur);
            SceneManager$1.ShowMoneyDel(val);
            if (SceneManager$1.mainUI) {
                SceneManager$1.mainUI.UpdateMoney();
            }
        }
        static EventLogic(event) {
            var key = "";
            var cur = 0;
            switch (event) {
                case 1:
                    key = "GameTimes";
                    break;
                case 2:
                    key = "WinTimes";
                    break;
                case 3:
                    key = "OpenTimes";
                    break;
                case 4:
                    key = "FindTimes";
                    break;
                case 5:
                    key = "BuyTimes";
                    break;
            }
            cur = DataManager.GetData(key);
            cur++;
            DataManager.SetData(key, cur);

            var chengjiu = DataManager.GetData("Achievment");
            var b = false;
            for (var key in DataManager.achievment) {
                var data = DataManager.achievment[key];
                if (data.event != event)
                    continue;
                if (data.before > 0 && chengjiu[key] == null)
                    continue;
                if (chengjiu[key] == -1)
                    continue;
                chengjiu[key] = cur > data.param ? data.param : cur;
                b = true;
            }
            if (b) {
                DataManager.SetData("Achievment", chengjiu);
            }
        }
        static CompleteAchievment(id) {
            var chengjiu = DataManager.GetData("Achievment");
            chengjiu[id] = -1;
            for (var key in DataManager.achievment) {
                var data = DataManager.achievment[key];
                if (data.before != parseInt(id))
                    continue;
                chengjiu[key] = DataManager.GetTimes(data.event);
            }
            DataManager.SetData("Achievment", chengjiu);
        }
        static GetTimes(event) {
            var key = "";
            var cur = 0;
            switch (event) {
                case 1:
                    key = "GameTimes";
                    break;
                case 2:
                    key = "WinTimes";
                    break;
                case 3:
                    key = "OpenTimes";
                    break;
                case 4:
                    key = "FindTimes";
                    break;
                case 5:
                    key = "BuyTimes";
                    break;
            }
            cur = DataManager.GetData(key);
            return cur;
        }
    }
    DataManager._dirty = true;
    DataManager.weapon = null;  //武器表
    DataManager.stage = null;   //关卡表
    DataManager.monster = null;  //怪物表
    DataManager.achievment = null;  //怪物表
    DataManager.shop = null;
    DataManager.version = "0.1.8";
    DataManager.UserData = {};

    DataManager.template = {
        "Name": { "default": "", "day": false },
        "curDay": { "default": 0, "day": false },
        "curStage": { "default": 1, "day": false },   //当前打到第几关
        "Money": { "default": 0, "day": false },
        "Model": { "default": "0", "day": false },
        "Has": { "default": { "0": 1 }, "day": false },
        "Guns": { "default": { "1": 1, "2": 0, "3": 0, "4": 0, "5": 0 }, "day": false },
        "Sound": { "default": 1, "day": false },//声音开关
        "Volume": { "default": 0.5, "day": false },  //音量
        "Rocker": { "default": 0.5, "day": false },  //灵敏度
        "Guide": { "default": 0, "day": false },  //新手指引进度
        "Achievment": { "default": {}, "day": false },   //成就
        "GameTimes": { "default": 0, "day": false },   //游戏次数
        "WinTimes": { "default": 0, "day": false },   //胜利次数
        "OpenTimes": { "default": 0, "day": false },   //打开宝箱次数
        "FindTimes": { "default": 0, "day": false },   //抓住对手次数
        "BuyTimes": { "default": 0, "day": false },   //购买次数
        "yingsishengming": { "default": 0, "day": false },   //购买次数
    };

    class MonsterManager extends Laya.Script3D {

        constructor() {
            super();
        }

        onEnable() {
        }

        onDisable() {
        }

        onCollisionEnter(collison) {
        }
        onCollisionStay(collison) {
            if (collison.other && collison.other.owner) {
                let otherName = collison.other.owner.name;
                if (otherName.indexOf("Door") != -1 || otherName.indexOf("Container") != -1 || otherName.indexOf("wall") != -1) {//持续的撞击门、墙或者箱子
                    this.knockTime += Laya.timer.delta;
                    if (this.knockTime > 1500) {
                        this.owner.getComponent(script_monster).change_ai();
                    }
                }
            }

        }
        onCollisionExit(collison) {
            if (collison.other && collison.other.owner) {
                let otherName = collison.other.owner.name;
                if (otherName.indexOf("Door") != -1 || otherName.indexOf("Container") != -1 || otherName.indexOf("wall") != -1) {//持续的撞击门、墙或者箱子
                    this.knockTime = 0;
                }
            }
        }
    }

    class LabelUtils {
        static getBaseUrl() {
            if (LabelUtils._ISDEBUG) {
                return this._DEBUG_BASE_URL;
            }
            return this._RELEASE_BASE_URL;
        }

        /**
         * 在没有获取到标签配置之前统一返回false
         * 在没有获取到是否是特殊省份时统一返回false
         *
         *
         * @param key
         * @returns {boolean}
         */
        static getLabel(key) {
            console.log("即将获取标签:::" + key);
            if (!key || !LabelUtils.initLabelSuccess || !LabelUtils.initIsSpecial) {
                return false;
            }
            console.log("正在获取标签>>>>:::" + key);

            if (LabelUtils.isSpecial) {
                if (LabelUtils.labels.special.length > 0) {
                    for (let i = 0, t = LabelUtils.labels.special.length; i < t; i++) {
                        let val = LabelUtils.labels.special[i];
                        // console.log(val.switchname + ">>>" + val.switchvalue + ">>>>key::" + key);
                        if (val.switchname == key) {
                            let b = val.switchvalue == 1;
                            console.log(key + "::" + b);
                            return b;
                        }
                    }
                    return false;


                } else {
                    return false;
                }
            } else {
                if (LabelUtils.labels.common.length > 0) {
                    for (let i = 0, t = LabelUtils.labels.common.length; i < t; i++) {
                        let val = LabelUtils.labels.common[i];
                        //   console.log(val.switchname + ">>>" + val.switchvalue + ">>>>key::" + key);

                        if (val.switchname == key) {
                            let b = val.switchvalue == 1;
                            console.log(key + "::" + b);
                            return b;
                        }
                    }
                    return false;
                } else {
                    return false;
                }
            }


        }
        static getValue(key, defaultValue) {


            if (LabelUtils.labels && LabelUtils.labels.hasOwnProperty("selfswitch")) {

                for (let i = 0; i < LabelUtils.labels.selfswitch.length; i++) {
                    let val = LabelUtils.labels.selfswitch[i];


                    if (val.switchname == key) {

                        let regFloat = /(-?\d+)(\.\d+)?/;//浮点数


                        let isFloatStr = regFloat.test(val.switchvalue);
                        if (isFloatStr) {

                            console.log("是个浮点");
                            let number = parseFloat(val.switchvalue);

                            return isNaN(number) ? val.switchvalue : number;


                        }

                        let regInt = /-?\d+/;//整数


                        let isIntStr = regInt.test(val.switchvalue);
                        if (isIntStr) {
                            console.log("是个整数");

                            let number1 = parseInt(val.switchvalue);
                            return isNaN(number1) ? val.switchvalue : number1;


                        }
                        return val.switchvalue;
                    }


                }
                return defaultValue;

            } else {
                return defaultValue;
            }
        }
        /**
         * 初始化步骤：
         *  1、异步执行ip定位，获取服务器标签配置，获取服务器上省份列表
         *  2、之后会判断当前省份是否是在屏蔽列表中，判断完成之后真正初始化完成
         *  3、
         * @param labelName
         */
        static initLabel(labelName) {
            console.log("initLabel:" + labelName);

            if (!!labelName && labelName.length > 0) {
                LabelUtils._labelName = labelName;
            }
            console.log("initLabel:  start");

            this._getMyLocation();
            this._fetchLabel();
            this._fetchLocationList();

        }
        /**
         * 重新刷新标签配置  从服务器重新获取标签配置
         */
        static refreshLabelConfig() {
            if (this.canRefresh) {
                this._fetchLabel();

            }
        }

        /**
         * 初始化是否是特殊省份
         * @private
         */
        static _initIsSpecial() {

            LabelUtils.isSpecial = false;
            let tmpId = 0;
            if (LabelUtils.location && LabelUtils.initLabelSuccess && LabelUtils.locationList) {
                for (let i = 0; i < LabelUtils.locationList.length; i++) {
                    if (LabelUtils.location == LabelUtils.locationList[i].name) {
                        tmpId = LabelUtils.locationList[i].id;
                        // console.log(this.location + "...." + this.locationList[i].name)
                        break;
                    }
                }
                if (LabelUtils.labels.blocked) {
                    let split = LabelUtils.labels.blocked.split(",");
                    if (split) {
                        for (let i = 0; i < split.length; i++) {
                            if (tmpId == split[i]) {
                                LabelUtils.isSpecial = true;
                                break
                            }

                        }
                    }

                }
            }
            LabelUtils.initIsSpecial = true;
            console.log("特殊省份isSpecial:" + LabelUtils.isSpecial);
        }
        static _fetchLocationList() {

            console.log("get Province List");
            LabelUtils._httpGets(LabelUtils.getBaseUrl() + "/config.json", false, function (res) {
                //console.log("_fetchLocationList Resp:>>" + res)
                LabelUtils._retryTimeLocationList++;

                if (res) {
                    let parse = JSON.parse(res);
                    if (parse.code == 1000) {
                        LabelUtils.locationList = parse.data;
                        console.log("_fetchLocationList Success");
                        LabelUtils._initIsSpecial();
                    } else {
                        Laya.timer.frameOnce(60 * LabelUtils._retryTimeLocationList, this, function () {
                            LabelUtils._fetchLocationList();
                        });
                    }
                } else {
                    Laya.timer.frameOnce(60 * LabelUtils._retryTimeLocationList, this, function () {
                        LabelUtils._fetchLocationList();
                    });
                }

            });

        }
        static _fetchLabel() {
            console.log("start   _fetchLabel");
            LabelUtils._retryTime++;

            LabelUtils._httpGets(this.getBaseUrl() + "/" + this._labelName + ".json?t=" + new Date().getTime(), false, function (res) {

                //console.log("_fetchLabel Resp:>>" + res);
                if (res != -1) {

                    let parse = JSON.parse(res);
                    if (!!parse && parse.code == 1000) {
                        LabelUtils.labels = parse.data;
                        LabelUtils.initLabelSuccess = true;
                        console.log("initLabel Success");
                        LabelUtils._initIsSpecial();
                        LabelUtils.canRefresh = true;
                    } else {
                        Laya.timer.frameOnce(60 * LabelUtils._retryTime, this, function () {
                            LabelUtils._fetchLabel();
                        });

                    }


                } else {
                    Laya.timer.frameOnce(60, this, function () {
                        LabelUtils._fetchLabel();
                    });
                }

            });

        }
        static _getMyLocation() {
            console.log("label:getLocation");

            this._httpGetsLocation("https://pv.sohu.com/cityjson?ie=utf-8", function (res) {
                //  console.log(res + ">>>>>>>>>>>");

                if (res != -1) {
                    let s2 = res.toString();
                    let s3 = s2.substring(s2.indexOf("{"), s2.lastIndexOf("}") + 1);
                    // console.log(s3)
                    let parse = JSON.parse(s3);
                    if (parse && parse.cname) {
                        let s = parse.cname;
                        // console.log(s)
                        if (s.indexOf("省") != -1) {
                            s = s.substring(0, s.indexOf("省"));
                        } else if (s.indexOf("市") != -1) {
                            s = s.substring(0, s.indexOf("市"));
                        } else {
                            s = s.substring(0, 2);
                        }
                        console.log(s);
                        LabelUtils.location = s;
                        LabelUtils._initIsSpecial();
                    } else {
                        Laya.timer.frameOnce(120, this, function () {
                            LabelUtils._getMyLocation();
                        });
                    }


                } else {

                    Laya.timer.frameOnce(120, this, function () {
                        LabelUtils._getMyLocation();
                    });
                }


            });
            console.log("label:getLocation  End");


        }

        static _httpGetsLocation(url, callback) {
            console.log("label:_httpGetsLocation 1111 ");
            // var xhr = new Laya.HttpRequest();
            // xhr.http.timeout = 10000;//设置超时时间；
            // xhr.once(Laya.Event.COMPLETE,this,function(e)
            // {
            //     var respone = e ;
            //     console.log("服务器返回完成："+respone);
            //     callback(respone);
            // });
            // xhr.once(Laya.Event.ERROR,this,function(data)
            // {
            //     console.log("服务器返回错误："+data);
            //     callback(-1);
            // });
            // xhr.on(Laya.Event.PROGRESS,this,function(data)
            // {
            //     console.log("服务器返回："+data);
            // });
            // var h = ["Content-Type", "application/x-www-form-urlencoded"] ;
            // xhr.send(url,"","get","text");
            LabelUtils._httpGets(url, "", callback);
        }

        static _httpGets(url, needHeader, callback) {
            console.log("label:HttpGets  ");

            if (window["wx"]) {
                var xhr = new Laya.HttpRequest();
                xhr.http.timeout = 10000;//设置超时时间；
                xhr.once(Laya.Event.COMPLETE, this, function (e) {
                    var respone = e;
                    console.log("服务器返回完成：" + respone);
                    callback(respone);
                });
                xhr.once(Laya.Event.ERROR, this, function (data) {
                    console.log("服务器返回错误：" + data);
                    callback(-1);
                });
                xhr.on(Laya.Event.PROGRESS, this, function (data) {
                    console.log("服务器返回：" + data);
                });
                xhr.send(url, "", "get", "text");
            } else {
                var xhr = new XMLHttpRequest();
                xhr.addEventListener("load", function () {
                    if (xhr.responseText) {
                        callback(xhr.responseText);
                    } else {
                        callback(-1);
                    }
                    console.log("服务器返回完成：" + xhr.responseText);
                });
                xhr.open("GET", url);
                xhr.send();
            }
        }

    }
    LabelUtils._ISDEBUG = false;
    LabelUtils._RELEASE_BASE_URL = "https://qygres.17666.mobi/label";
    LabelUtils._DEBUG_BASE_URL = "http://192.168.0.242:19800/label";
    LabelUtils._labelName = "";
    LabelUtils.location = "";
    LabelUtils.labels = null;
    LabelUtils._retryTime = 0;
    LabelUtils.isSpecial = false;
    LabelUtils._retryTimeLocationList = 0;
    LabelUtils.locationList = [];
    LabelUtils.initLabelSuccess = false;
    LabelUtils.initIsSpecial = false;

    window.SDK_apk = {
        VideoSuccess: function () {
            console.log('执行看完视频成功回调');
            if (SDK_apk.successs_callback != null) {
                SDK_apk.successs_callback();
                SDK_apk.successs_callback = null;
            }
        },

        VideoFail: function () {
            console.log('执行看完视频失败回调');
            if (SDK_apk.err_callback != null) {
                SDK_apk.err_callback();
                SDK_apk.err_callback = null;
            }
        },

        VideoCancel: function () {
            console.log('执行看完视频取消回调');
            if (SDK_apk.cancel_callback != null) {
                SDK_apk.cancel_callback();
                SDK_apk.cancel_callback = null;
            }
        },

        videoClose() {
            var sj = LabelUtils.getValue("sj", 30);
            console.log("间隔时间:" + sj);

            SDK_apk.showVideo = false;
            clearTimeout(SDK_apk.TIMEOut);
            SDK_apk.TIMEOut = setTimeout(() => {
                SDK_apk.showVideo = true;
            }, sj * 1000);
        }
    };

    class SDK_apk {
        static Init(callback) {
            LabelUtils.initLabel("tkrcmm_zbswb_101_vivo_apk_20211222");
            setTimeout(() => {
                var tlsj = LabelUtils.getValue("tlsj", 60);
                var sj = LabelUtils.getValue("sj", 60);
                console.log("套路时间:" + tlsj + "      间隔时间:" + sj);

                if (LabelUtils.getLabel("tlsj")) {
                    setTimeout(() => {
                        SDK_apk.tlsj = true;
                    }, tlsj * 1000);
                }

                clearTimeout(SDK_apk.TIMEOut);
                SDK_apk.TIMEOut = setTimeout(() => {
                    SDK_apk.showVideo = true;
                }, sj * 1000);

                if (callback) {
                    callback();
                }
            }, 1000);
        }

        static goToMoreGame() {
            if (window.android) {
                window.android.goToMoreGame();
            }
        }

        static showYSSM() {
            if (window.android) {
                window.android.showYSSM();
            }
        }

        static showEmail() {
            if (window.android) {
                window.android.showEmail();
            }
        }

        static showVideoAD1(successs_callback) {
            SDK_apk.successs_callback = successs_callback;
            if (window.android) {
                window.android.showVideoAD();
            } else {
                if (SDK_apk.successs_callback) {
                    SDK_apk.successs_callback();
                    SDK_apk.successs_callback = null;
                }
            }
        }

        static showVideoAD(successs_callback, err_callback, cancel_callback) {
            SDK_apk.successs_callback = successs_callback;
            SDK_apk.err_callback = err_callback;
            SDK_apk.cancel_callback = cancel_callback;

            if (window.android) {
                if (SDK_apk.showVideo && SDK_apk.tlsj) {
                    window.android.showVideoAD();
                } else {
                    if (SDK_apk.successs_callback) {
                        SDK_apk.successs_callback();
                        SDK_apk.successs_callback = null;
                    }
                }
            } else {
                if (SDK_apk.successs_callback) {
                    SDK_apk.successs_callback();
                    SDK_apk.successs_callback = null;
                }
            }
        }

        static showNativeAd() {
            if (window.android) {
                if (LabelUtils.getLabel("cp")) {
                    window.android.showNativeAd();
                }
            }
        }

        static showInterstitialAd() {
            if (window.android) {
                if (LabelUtils.getLabel("cp")) {
                    window.android.showInterstitialAd();
                }
            }
        }

        static showNative3() {
            if (window.android) {
                if (LabelUtils.getLabel("cp")) {
                    window.android.showNative3();
                }
            }
        }

        static closeNative3() {
            if (window.android) {
                if (LabelUtils.getLabel("cp")) {
                    window.android.closeNative3();
                }
            }
        }

        static showBanner() {
            if (window.android) {
                if (LabelUtils.getLabel("banner")) {
                    window.android.showBanner();
                }
            }
        }

        static closeBanner() {
            if (window.android) {
                if (LabelUtils.getLabel("banner")) {
                    window.android.closeBanner();
                }
            }
        }

        static showIcon() {
            if (window.android) {
                if (LabelUtils.getLabel("icon")) {
                    window.android.showIcon();
                }
            }
        }
    }
    SDK_apk.successs_callback = null;
    SDK_apk.err_callback = null;
    SDK_apk.cancel_callback = null;

    SDK_apk.TIMEOut = null;
    SDK_apk.tlsj = false;
    SDK_apk.showVideo = false;

    class ui_game extends Laya.Scene {
        constructor() {
            super();
        }
        onDestroy() {
            console.log("onDestroy ui_game");
            SceneManager$1.isGamming = false;
            script_player.isvideoRun = false;
        }
        onEnable() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.messageList = [];
            SceneManager$1.objects = [];
            SceneManager$1.gameUI = this;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.btn_action.on(Laya.Event.CLICK, this, this.onClickAction);
            this.btn_aim.on(Laya.Event.CLICK, this, this.onClickAim);
            this.btn_jump.on(Laya.Event.CLICK, this, this.onClickJump);
            this.btn_run.on(Laya.Event.MOUSE_DOWN, this, this.onClickRun);

            Laya.timer.loop(20, this, this.update);
            // Laya.timer.loop(5000, this, this.creteateIcon);

            //结束界面，成功双倍
            this._ui_win_double.on(Laya.Event.CLICK, this, this.onClickDouble);
            this._ui_win_continue.on(Laya.Event.CLICK, this, this.onClickContinue);
            this._ui_win_notice.on(Laya.Event.CLICK, this, this.onClickNoticeWin);
            this._guide.on(Laya.Event.CLICK, this, this.onClickGuide);
            this._btn_exit.on(Laya.Event.CLICK, this, this.GameOver, [false]);
            // //设置界面
            this.initSettingUI();

            this.Init();
            SceneManager$1.pause = false;
            this.over = false;

            //新手指引

            if (DataManager.GetData("Guide") == 0) {
                this.openGuide(0);
            }
            this.rewardNum = 0;
            this.randomJBNum = 0;
            SceneManager$1.overgame = false;
            console.log('进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏进入游戏');
            this.boxnum = 0;
            SceneManager$1.pauseUI = false;
        }

        openGuide(index) {
            if (1 > 0)
                return;
            this.guide = index;
            this.btn_squat.visible = index == 1;
            this.btn_aim.visible = index == 2;
            this.btn_run.visible = index == 3;
            this.btn_action.visible = index == 4;

            this._guide1.visible = index == 0;
            this._guide2.visible = index == 1;
            this._guide3.visible = index == 2;
            this._guide4.visible = index == 3;
            this._guide5.visible = index == 4;
            this._guide.visible = true;
            SceneManager$1.pause = true;

            this.guide1 = SceneManager$1.resScene.getChildByName("guide1");
            this.guide2 = SceneManager$1.resScene.getChildByName("guide2");
            this.guide1.active = index == 0;
            this.guide2.active = false;
            this.guide = index;

        }
        closeGuide() {
            this._guide.visible = false;
            SceneManager$1.pause = false;
            if (this.guide == 3)
                this.guide2.active = true;

        }
        onClickGuide() {
            if (this.guide == 0)
                this.closeGuide();
        }

        onDisable() {
            Laya.timer.clearAll(this);
        }
        GetMoveSpeed() {
            return 2;
        }
        initSettingUI() {
            this._ui_btn_pause.on(Laya.Event.CLICK, this, this.onClickPause);
            this._ui_pause_home.on(Laya.Event.CLICK, this, this.onClickGoBack);
            this._ui_pause_continue.on(Laya.Event.CLICK, this, this.onClickBack);

            this._ui_pause_sound.on(Laya.Event.MOUSE_UP, this, this.onMouseUp);
            this._ui_pause_sound.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            this._ui_pause_rocker.on(Laya.Event.MOUSE_UP, this, this.onMouseUp);
            this._ui_pause_rocker.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);

            let v = DataManager.GetData("Volume");
            this._ui_pause_sound.getChildByName("img").x = v * this._ui_pause_sound.width;
            this._ui_pause_sound.value = v;
            v = DataManager.GetData("Rocker");
            this._ui_pause_rocker.getChildByName("img").x = v * this._ui_pause_rocker.width;
            this._ui_pause_rocker.value = v;
        }
        onMouseUp(e) {
            let img = e.target.getChildByName("img");
            img.x = e.target.mouseX;

            this.onMouseOut(e);
            let v = img.x / e.target.width;
            e.target.value = v;
            this.onSet(e.target.name, v);
        }
        onSet(name, v) {
            if (name == "sound") {
                SceneManager$1.SetVolume(v);
                DataManager.SetData("Volume", v);
            }
            else if (name == "rocker") {
                SceneManager$1.SetRocker(v);
                DataManager.SetData("Rocker", v);
            }
        }
        onMouseDown(e) {
            let img = e.target.getChildByName("img");
            e.target.on(Laya.Event.MOUSE_MOVE, this, function (ee) {
                img.x = ee.target.mouseX;
                let v = img.x / e.target.width;//300;
                e.target.value = v;
                this.onSet(e.target.name, v);
            });
            e.target.once(Laya.Event.MOUSE_OUT, this, this.onMouseOut);
        }
        onMouseOut(e) {
            e.target.off(Laya.Event.MOUSE_OUT, this);
            e.target.off(Laya.Event.MOUSE_MOVE, this);
        }
        onClickBack() {
            this._ui_pause.visible = false;
            SceneManager$1.pause = false;
            SceneManager$1.pauseUI = false;
            SDK_apk.closeNative3();
        }
        onClickPause() {
            this._ui_pause.visible = true;
            SceneManager$1.pause = true;
            SceneManager$1.pauseUI = true;
            SDK_apk.showNative3();
        }

        Init() {
            //场景
            this.stageData = DataManager.stage[SceneManager$1.curStage];
            Laya.stage.addChildAt(SceneManager$1.resScene, 0);
            this.InitPlayer();
            this.RedList = {};

            this.ResetMonster();
            this.InitMiniMap();
            //需要打开的箱子数
            this._task1.visible = false;
            this._task2.visible = false;
            this._task3.visible = false;
            this._task4.visible = false;
            this._task5.visible = false;

            this._task1a.visible = true;
            this._task2a.visible = true;
            this._task3a.visible = true;
            this._task4a.visible = true;
            this._task5a.visible = true;
            this.btn_action.gray = SceneManager$1.model == 1;

            this.itemNum = 0;
            this.needItem = 5;

            this.time = this.stageData.time * 1000;
            this.createItem();
            this.InitFont();
            SceneManager$1.isGamming = true;
            console.log('游戏开始');
        }
        InitFont() {

        }

        InitMiniMap() {
        }

        ResetMonster() {
            this.monsterNum = 4;
            this._monsterNum.text = SceneManager$1.model == 2 ? "剩余对手人数:" : "剩余己方人数:";
            this._lab_monster.text = "" + this.monsterNum;
            this.CreateMonster();
        }

        onMonsterDeath(name) {
            var message = name + "被" + this.bossName + "抓到了，其他人请注意躲藏";
            this.PushMessage(message);
            this.monsterNum--;
            this._lab_monster.text = "" + this.monsterNum;
            if (this.monsterNum == 0) {
                this.GameOver(SceneManager$1.model == 2);
            }
            // if (SceneManager.model == 2) {
            //     Laya.Scene.open("openBox.scene", false, 1);
            // }
        }

        CreateMonster() {
            this.monster = [];
            for (let i = 0; i < this.monsterNum; i++) {
                var id = i;
                if (SceneManager$1.model == 2) {//第二种模式id从1开始
                    id++;
                }

                var info = null;
                if (SceneManager$1.model == 1 && i == 0) {
                    var n = SceneManager$1.RandomInt(0, SceneManager$1.bossName.length - 1);
                    info = SceneManager$1.bossName[n];
                }
                else {
                    var n = SceneManager$1.RandomInt(0, SceneManager$1.monsterName.length - 1);
                    info = SceneManager$1.monsterName[n];
                }

                let modelPrefab = SceneManager$1.resModels.getChildByName(info.name);
                let boss = Laya.Sprite3D.instantiate(modelPrefab, SceneManager$1.resScene);
                boss.transform.localPosition = new Laya.Vector3(0, 0, 0);
                boss.name = "monster";
                if (SceneManager$1.model == 1 && i == 0) {//模式1 给boss加提示
                    let m = SceneManager$1.resModels.getChildByName("Arrow");
                    let mm = Laya.Sprite3D.instantiate(m, boss);
                    mm.transform.position.x = boss.transform.position.x;
                    mm.transform.position.y = 2;
                    mm.transform.position.z = boss.transform.position.z;
                    SceneManager$1.boss = boss;
                }
                boss.addComponent(MonsterManager);
                let bossScript = boss.addComponent(script_monster);
                bossScript.init(i == 0 && SceneManager$1.model == 1, id);
                this.monster.push(bossScript);
                SceneManager$1.objects.push(boss);
                console.log("创建怪物       ", info.name);
            }
        }

        InitPlayer() {
            let model = DataManager.GetData("Model");
            let data = DataManager.shop[model];
            script_player.initPlayer();
            let modelPrefab = SceneManager$1.resModels.getChildByName(data.Model);
            SceneManager$1.player = Laya.Sprite3D.instantiate(modelPrefab, SceneManager$1.resScene);
            SceneManager$1.playerController = SceneManager$1.player.addComponent(Laya.CharacterController);

            let sphereShape = new Laya.CapsuleColliderShape(1, 1.8);
            // sphereShape.localOffset = new Laya.Vector3(0, 0, 0.4);
            SceneManager$1.playerController.colliderShape = sphereShape;
            SceneManager$1.player.name = "player";
            SceneManager$1.playerController.stepHeight = 0.3;
            SceneManager$1.player.transform.localRotation = SceneManager$1.player.transform.localRotation;
            SceneManager$1.camera = SceneManager$1.player.addChild(new Laya.Camera());
            SceneManager$1.camera.transform.translate(new Laya.Vector3(0, 3.8, -3.4));
            SceneManager$1.camera.transform.rotate(new Laya.Vector3(-20, 180, 0), true, false);
            SceneManager$1.camera.fieldOfView = 60;
            SceneManager$1.camera.near = 0.01;
            let cameraScript = SceneManager$1.camera.addComponent(CameraMoveScript);

            let initpos = SceneManager$1.resScene.getChildByName("initPos").getChildByName("player");
            SceneManager$1.player.transform.position = initpos.transform.position;
            var playerPos = SceneManager$1.player.transform.position.clone();
            playerPos.y -= 0.5;
            SceneManager$1.player.transform.position = playerPos;

            SceneManager$1.playerAnimator = SceneManager$1.player.getComponent(Laya.Animator);
            SceneManager$1.miniIndex = 0;
            SceneManager$1.objects.push(SceneManager$1.player);

            this.hp = 100;
            this.updateHP();
            var name = DataManager.GetData("Name");
            if (SceneManager$1.model == 2) {
                SceneManager$1.boss = SceneManager$1.player;
                this.bossName = name;
            }

            this._lab_name.text = name;
        }
        InitItem() {
            let item = SceneManager$1.resScene.getChildByName("item");
            let animator = item.getChildAt(0).getComponent(Laya.Animator);
            animator.play("Box_3_closed", 0, false);
            SceneManager$1.itemAnimator = animator;
        }
        updateHP() {
            //this.lab_hp.text = "" + this.hp;
        }

        GameOver(win) {
            this.openGameOver(win);
            this.over = true;
            SceneManager$1.pause = true;
            DataManager.EventLogic(1);
            if (win) {
                DataManager.EventLogic(2);
            }
        }

        openGameOver(bWin) {
            SceneManager$1.overgame = true;
            this._lab.text = SceneManager$1.model == 1 ? "开箱数量" : "抓住对手";
            this._ui_gameover.width = Laya.stage.width;
            this._ui_gameover.height = Laya.stage.height;

            //结束界面的默认勾选
            this._ui_win_double.visible = false;
            this._ui_win_ok.visible = false;
            this._ui_win_continue.visible = true;
            this._ui_gameover.visible = true;

            var base = SceneManager$1.rewardBase * (SceneManager$1.model == 1 ? 1 : 2);
            // this.reward = base + (bWin ? (this.rewardNum * SceneManager.rewardBox) : 0);
            this.reward = base + this.rewardNum * SceneManager$1.rewardBox;
            DataManager.AddMoney(this.reward);

            //赋值基础奖励显示
            this.labBaseSeek.text = SceneManager$1.rewardBase * 2 + "";
            this.labBasePrize1.text = SceneManager$1.rewardBase + "";
            this.labBasePrize2.text = SceneManager$1.rewardBase + "";
            this.labBasePrize3.text = SceneManager$1.rewardBase + "";
            this.labBasePrize4.text = SceneManager$1.rewardBase + "";

            if (SceneManager$1.model == 1) {
                this.labNameSeeker.color = "#ffffff";
                this.labNameMonster1.color = "#ff0000";
            } else {
                this.labNameSeeker.color = "#ff0000";
                this.labNameMonster1.color = "#ffffff";
            }
            //赋值名称显示
            this.labNameSeeker.text = SceneManager$1.model == 1 ? SceneManager$1.gameUI.bossName : DataManager.GetData("Name");
            this.labNameMonster1.text = SceneManager$1.model == 1 ? DataManager.GetData("Name") : this.monster[0].namestr;
            this.labNameMonster2.text = this.monster[1].namestr;
            this.labNameMonster3.text = this.monster[2].namestr;
            this.labNameMonster4.text = this.monster[3].namestr;

            //赋值抓人或者开箱数量显示
            this.labelFinishSeek.text = SceneManager$1.model == 1 ? this.monster[0].finishedTaskNum : this.rewardNum + "";
            this.labelFinish1.text = SceneManager$1.model == 1 ? this.rewardNum : this.monster[0].finishedTaskNum + "";
            this.labelFinish2.text = this.monster[1].finishedTaskNum + "";
            this.labelFinish3.text = this.monster[2].finishedTaskNum + "";
            this.labelFinish4.text = this.monster[3].finishedTaskNum + "";

            //赋值总奖励显示
            let seekWin = (SceneManager$1.model == 1 && bWin == false) || (SceneManager$1.model == 2 && bWin);//躲藏模式自己输了或者抓捕模式自己赢了
            // this.labAllPrizeSeek.text = (parseInt(this.labBaseSeek.text) + (seekWin ? parseInt(this.labelFinishSeek.text) * SceneManager.rewardBox : 0)) + "";
            // this.labAllPrize1.text = (parseInt(this.labBasePrize1.text) + (seekWin ? 0 : parseInt(this.labelFinish1.text) * SceneManager.rewardBox)) + "";
            // this.labAllPrize2.text = (parseInt(this.labBasePrize2.text) + (seekWin ? 0 : parseInt(this.labelFinish2.text) * SceneManager.rewardBox)) + "";
            // this.labAllPrize3.text = (parseInt(this.labBasePrize3.text) + (seekWin ? 0 : parseInt(this.labelFinish3.text) * SceneManager.rewardBox)) + "";
            // this.labAllPrize4.text = (parseInt(this.labBasePrize4.text) + (seekWin ? 0 : parseInt(this.labelFinish4.text) * SceneManager.rewardBox)) + "";
            this.labAllPrizeSeek.text = (parseInt(this.labBaseSeek.text) + parseInt(this.labelFinishSeek.text) * SceneManager$1.rewardBox) + "";
            this.labAllPrize1.text = (parseInt(this.labBasePrize1.text) + parseInt(this.labelFinish1.text) * SceneManager$1.rewardBox) + "";
            this.labAllPrize2.text = (parseInt(this.labBasePrize2.text) + parseInt(this.labelFinish2.text) * SceneManager$1.rewardBox) + "";
            this.labAllPrize3.text = (parseInt(this.labBasePrize3.text) + parseInt(this.labelFinish3.text) * SceneManager$1.rewardBox) + "";
            this.labAllPrize4.text = (parseInt(this.labBasePrize4.text) + parseInt(this.labelFinish4.text) * SceneManager$1.rewardBox) + "";

            this._ui_gameover.scaleX = 0.5;//
            this._ui_gameover.scaleY = 0.5;// = (0.1, 0.1);
            this._ui_gameover.visible = true;
            Laya.Tween.to(this._ui_gameover, { scaleX: 1, scaleY: 1 }, 200);
            SceneManager$1.StopSound();//游戏结束的时候先停止一遍声音播放（防止这个时候没有抬起鼠标导致走路声音一直播放的情况）
            SceneManager$1.PlaySound(bWin ? "win" : "lose");
            this._img_win.visible = bWin;
            this._img_lose.visible = !bWin;
            if (bWin) {
                console.log("xuhong进入胜利界面");
                SceneManager$1.showCP[6]++;
                if (SceneManager$1.showCP[6] % 2 == 0) {
                    console.log("显示插屏");
                    SDK_apk.showNativeAd();
                }
            } else {
                console.log("xuhong进入失败界面");
                SceneManager$1.showCP[5]++;
                if (SceneManager$1.showCP[5] % 2 == 0) {
                    console.log("显示插屏");
                    SDK_apk.showNativeAd();
                }
            }
        }
        checkItem() {
            if (SceneManager$1.model == 2)
                return;
            let player = SceneManager$1.player;
            let camera = SceneManager$1.camera;
            let scene = SceneManager$1.resScene;

            let point = new Laya.Vector2(0, 0);
            point.x = Laya.stage.width / 2;
            point.y = Laya.stage.height / 2;
            // if (PlatformManager.curPlat != null) {
            //     var Systeminfo = qg.getSystemInfoSync();
            //     point.x = Systeminfo.screenWidth * 0.5 * Systeminfo.pixelRatio;
            //     point.y = Systeminfo.screenHeight * 0.5 * Systeminfo.pixelRatio;
            // }
            let _ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            camera.viewportPointToRay(point, _ray);
            let _outHitInfo = [];
            scene.physicsSimulation.rayCastAll(_ray, _outHitInfo);
            //     let ret = null;
            if (_outHitInfo.length == 0) {
                return;
            }
            //开盒子距离
            let bHas = false;
            for (let i = 0; i < _outHitInfo.length; i++) {
                let r = _outHitInfo[i];
                if (r.succeeded) {
                    if (r.collider.owner.name != "box")
                        continue;
                    let dis = Laya.Vector3.distance(r.point, player.transform.position);
                    if (dis < 4) {
                        bHas = true;
                        this.item = r.collider.owner;
                        break;
                    }
                }
            }
            if (bHas == false) {
                this.item = null;
                this.clearAction();
            }
            this.btn_action.gray = this.item == null;
        }

        addName(obj) {
            this._nameBox.addChild(obj);
        }

        updateMiniMap() {
            // var camera = SceneManager.camera;
            // var pos = new Laya.Vector3(0, 0, 0);
            // camera.viewport.project(SceneManager.player.transform.position, camera.projectionViewMatrix, pos);
            // this._name1.pos(pos.x / Laya.stage.clientScaleX - 50, pos.y / Laya.stage.clientScaleY - 500);

            // let obj = SceneManager.objects[SceneManager.miniIndex];
            // this.miniCamera.transform.position = new Laya.Vector3(obj.transform.position.x, obj.transform.position.y +3.5, obj.transform.position.z)
        }

        creteateIcon() {

        }

        update() {
            this.updateMiniMap();
            this.checkItem();
            script_player.Tick();
            if (this._power.visible) {
                let power = script_player._power;
                let v = power / script_player._powerMax * 360;
                this._sp.graphics.clear();
                this._sp.graphics.drawPie(0, 0, 75, -90, -90 + v, "#ff0000", "#ff0000", 1);
                if (v == 0 && !script_player.runvideo) {
                    script_player.runvideo = true;
                }
            }
            for (let i = 0; i < this.monster.length; i++) {
                this.monster[i].update();
            }

            this.updateMessage();
            this.guideTick();
            this.updateTime();
        }
        updateTime() {
            if (SceneManager$1.pause || SceneManager$1.overgame) {
                return;
            }
            this.time -= Laya.timer.delta;
            if (this.time < 0) {
                this.GameOver(false);
                return;
            }
            let m = Math.floor(this.time / 1000 / 60);
            let s = Math.floor(this.time / 1000) % 60;
            this._time.text = (m >= 10 ? m : ("0" + m)) + ":" + (s >= 10 ? s : "0" + s);
        }
        //检查成就
        checkTask() {
            let info = DataManager.GetData("Achievment");
            for (var key in DataManager.achievment) {
                let data = DataManager.achievment[key];
                if (data.stage != SceneManager$1.curStage)
                    continue;
                if (info[key])
                    continue;
                if (data.event == 1) {
                    info[key] = 1;
                }
                else if (data.event == 1) {
                    let t = (this.stageData.time * 1000 - this.time) / 1000;
                    if (t <= data.param) {
                        info[key] = 1;
                    }
                }
            }
            DataManager.SetData("Achievment", info);
        }
        guideTick() {
            if (this.guide1 == null)
                return;
            if (this.guide1.active == true) {
                let dis = Laya.Vector3.distance(SceneManager$1.player.transform.position, this.guide1.transform.position);
                if (dis < 2) {
                    this.openGuide(1);
                }
            }
            else if (this.guide2.active == true) {
                let dis = Laya.Vector3.distance(SceneManager$1.player.transform.position, this.guide2.transform.position);
                if (dis < 1) {
                    this.openGuide(4);
                }
            }
        }
        addRed(id, pos) {
            let red = new Laya.Image("ui/icon/red.png");

            this._box.addChild(red);
            this.RedList[id] = red;

            this.updateRed(id, pos);
        }

        onClickAction() {
            this.test();
            console.log("显示视频");
            let self = this;
            SceneManager$1.pause = true;
            SDK_apk.showVideoAD(function () {
                SceneManager$1.pause = false;
                if (SceneManager$1.model == 1) {//躲藏
                    if (self.item == null) {
                        return;
                    }
                    if (self.guide == 4) {
                        self.closeGuide();
                    }
                    script_player.Action();
                    self._actionBar.value = 0;
                    self._actionBar.visible = true;
                    Laya.timer.loop(100, self, self.actionBarTick);
                }
                else {//抓捕
                    self.hitTarget = null;
                    let player = SceneManager$1.player;
                    for (let i = 0; i < self.monster.length; i++) {
                        let monster = self.monster[i];
                        if (monster.isDeath())
                            continue;

                        let distance = Laya.Vector3.distance(player.transform.position, monster.owner.transform.position);
                        if (distance < SceneManager$1.playCanGetDis) {
                            self.hitTarget = monster;
                            break;
                        }
                    }
                    script_player.Attack();
                    if (self.hitTarget) {
                        Laya.timer.once(100, self, function () {
                            if (self.hitTarget && self.hitTarget.isDeath() == false) {
                                DataManager.EventLogic(4);
                                self.rewardNum++;
                                self.hitTarget.onHit();
                            }
                        });
                    }
                }
            }, function () {
                SceneManager$1.pause = false;
            }, function () {
                SceneManager$1.pause = false;
            });
        }
        clearAction() {
            if (this._actionBar.visible) {
                this._actionBar.visible = false;
                Laya.timer.clear(this, this.actionBarTick);
            }
        }
        actionBarTick() {
            if (SceneManager$1.pause)
                return;
            this._actionBar.value += 0.02;
            if (this.item == null || this.item.name != "box") {
                Laya.timer.clear(this, this.actionBarTick);
                this._actionBar.visible = false;
                script_player.Idle(true);
            }
            else if (this._actionBar.value >= 1) {
                Laya.timer.clear(this, this.actionBarTick);
                script_player.Idle(true);
                this._actionBar.visible = false;
                if (this.item && this.item.name == "box") {
                    this.rewardNum++;
                    this.item.name = "opened";
                    DataManager.EventLogic(3);
                    this.PickUpItem(this.item, DataManager.GetData("Name"));
                    this.item = null;
                }
            }
        }
        CreateNewBox() {
            if (this.over)
                return;
            let temp = null;
            var posList = [];
            for (var i = 0; i < SceneManager$1.itemPos.length; i++) {
                for (var j = 0; j < this.boxList.length; j++) {
                    if (this.boxList[j].active == false)
                        continue;
                    if (Laya.Vector3.distance(SceneManager$1.itemPos[i], this.boxList[j].transform.position) < 1)
                        continue;
                    posList.push(i);
                }
            }
            let n = SceneManager$1.RandomInt(0, posList.length - 1);
            let pos = posList[n];
            posList.splice(n, 1);
            let modelPrefab = SceneManager$1.resModels.getChildByName("item");
            let item = Laya.Sprite3D.instantiate(modelPrefab, SceneManager$1.resScene);
            item.transform.position = SceneManager$1.itemPos[pos];
            let animator = item.getChildAt(0).getComponent(Laya.Animator);
            animator.play("Box_3_closed", 0, false);
            item.name = "box";
            this.boxList.push(item);
        }

        updateItemNum() {
            this.itemNum++;
            this._task1a.visible = this.itemNum < 5;
            this._task2a.visible = this.itemNum < 4;
            this._task3a.visible = this.itemNum < 3;
            this._task4a.visible = this.itemNum < 2;
            this._task5a.visible = this.itemNum < 1;

            this._task1.visible = this.itemNum >= 5;
            this._task2.visible = this.itemNum >= 4;
            this._task3.visible = this.itemNum >= 3;
            this._task4.visible = this.itemNum >= 2;
            this._task5.visible = this.itemNum >= 1;


            if (this.itemNum >= this.needItem) {
                this.GameOver(SceneManager$1.model == 1);
            }
            else {
                this.CreateNewBox();
            }
        }

        PickUpItem(item, name) {
            item.name = 'opened';
            let animator = item.getChildAt(0).getComponent(Laya.Animator);
            animator.play("Box_3_open", 0, false);
            this.updateItemNum();
            Laya.timer.once(800, this, function () {
                item.active = false;
            });

            var n = this.needItem - this.itemNum;
            if (n > 0) {
                this.PushMessage(name + "打开了一个宝箱，剩余" + n + "个宝箱待找到");
            }
        }

        checkHitObject(obj) {
            let name = obj.parent.name;
            if (name.indexOf("monster") >= 0) {
                let id = name.substr(name.lastIndexOf("_") + 1);
                return parseInt(id);
            }
            return -1;
        }
        onClickAim() {
            SceneManager$1.miniIndex++;
            if (SceneManager$1.miniIndex >= SceneManager$1.objects.length) {
                SceneManager$1.miniIndex = 0;
            }
            if (this.guide == 2) {
                this.openGuide(3);
            }
        }

        openAim() {
            let self = this;
            let camera = SceneManager$1.camera.getChildByName("Camera");
            script_player.Aim(true);
            if (this.weaponInfo.aiming) {
                Laya.timer.once(300, this, function () {
                    self._aim2.visible = true;
                    self._aim.visible = false;
                    camera.fieldOfView = 20;
                    SceneManager$1.gunModel.active = false;
                });
            }
            else {
                camera.fieldOfView = 40;
                SceneManager$1.gunModel.transform.localPosition = new Laya.Vector3(-0.07, -0.1, 0.06);
            }
        }
        closeAim() {
            let self = this;
            let camera = SceneManager$1.camera.getChildByName("Camera");
            script_player.Aim(false);
            if (this.weaponInfo.aiming) {
                SceneManager$1.gunModel.active = true;
            };
            this._aim2.visible = false;
            this._aim.visible = true;
            camera.fieldOfView = 60;
            SceneManager$1.gunModel.transform.localPosition = new Laya.Vector3(-0.15, -0.1, -0.06);
        }
        onClickRun() {
            if (script_player._isRun)
                return;
            if (this._power.visible)
                return;
            // if (script_player.runvideo) {
            //     if (script_player._power == 5000) {
            //         script_player.runvideo = false;
            //     }
            // }
            // if (script_player.runvideo) {
            //     if (PlatformManager.curPlat != null) {
            //         AdsManager.showAD(function () {
            //             script_player.isvideoRun = true;
            //             script_player.runvideo = false;
            //         }, function () {

            //         }, function () {

            //         });
            //     } else {
            //         script_player.isvideoRun = true;
            //         script_player.runvideo = false;
            //     }
            // } else {
            this.btn_run.on(Laya.Event.MOUSE_OUT, this, this.onAmong_Walk);
            this.btn_run.on(Laya.Event.MOUSE_UP, this, this.onAmong_Walk);
            this.btn_run.on(Laya.Event.MOUSE_DOWN, this, function () {
                SceneManager$1.pause = true;
                SDK_apk.showVideoAD(function () {
                    SceneManager$1.pause = false;
                }, function () {
                    SceneManager$1.pause = false;
                }, function () {
                    SceneManager$1.pause = false;
                });
            });
            script_player.Squat(false);
            script_player.Run(true);

            this._sp.graphics.clear();
            this._power.visible = true;
            if (this.guide == 3) {
                this.closeGuide();
            }
            // }
        }
        onAmong_Walk() {
            script_player.Run(false);
            this.btn_run.off(Laya.Event.MOUSE_OUT, this, this.onAmong_Walk);
            this.btn_run.off(Laya.Event.MOUSE_UP, this, this.onAmong_Walk);
            this._power.visible = false;
        }

        onClickJump() {
            console.log("显示视频");
            SceneManager$1.pause = true;
            SDK_apk.showVideoAD(function () {
                SceneManager$1.pause = false;
                var date = new Date();
                var timeStr = date.getMinutes() + ":" + date.getSeconds() + ":" + date.getMilliseconds();
                if (script_player.IsAnimator() == true)
                    return;
                script_player.Jump();
            }, function () {
                SceneManager$1.pause = false;
            }, function () {
                SceneManager$1.pause = false;
            });
        }

        playerMove(dirX, dirY) {
            this.clearAction();
            if (script_player.IsAnimator())
                return;
            script_player.Move(dirX, dirY);
        }

        //失败界面
        onClickGoBack() {
            SceneManager$1.GoBackToMain();
        }
        //点击复活
        onClickRelive() {
            this.hp = 100;
            this.over = false;
            this.updateHP();
            this.closeGameOverUI();
            SceneManager$1.PlaySound("relive");
        }
        closeGameOverUI() {
            SceneManager$1.pause = false;
            this._ui_gameover.visible = false;
        }
        //点击重新开始
        onClickReStart() {
            SceneManager$1.GoBackToMain();
        }
        onClickNoticeWin() {
            // this._ui_win_ok.visible = !this._ui_win_ok.visible;
            // this._ui_win_double.visible = this._ui_win_ok.visible;
            // this._ui_win_continue.visible = !this._ui_win_ok.visible;
        }

        // onClickNotice() {
        //     this._relive_ok.visible = !this._relive_ok.visible;
        //     this._ui_game_restart.visible = !this._relive_ok.visible;
        //     this._ui_game_relive.visible = this._relive_ok.visible;
        // }

        //双倍领取
        // onClickDouble() {
        //     AdsManager.showAD(
        //         () => {
        //             console.log("ui_game        onClickDouble       广告观看完毕");
        //             DataManager.AddMoney(this.reward);
        //             this.onClickContinue();
        //         },
        //         () => {
        //             console.log("ui_game        onClickDouble       广告没有观看完毕");
        //         }, () => {
        //             console.log("ui_game        onClickDouble       调用广告失败");
        //         }
        //     );
        // }

        //继续下一关
        onClickContinue() {
            console.log("显示视频");
            let self = this;
            SDK_apk.showVideoAD(function () {
                self._ui_gameover.visible = false;
                SceneManager$1.GoBackToMain();
            }, function () {
                self._ui_gameover.visible = false;
                SceneManager$1.GoBackToMain();
            }, function () {

            });
        }

        showWarning() {
            this._ui_warning.visible = true;
        }
        closeWarning() {
            this._ui_warning.visible = false;
        }
        test() {
            // this.GameOver(false);
        }

        onPlayerDeath() {
            if (this.over)
                return;
            SceneManager$1.pause = true;
            this._death.visible = true;
            console.log("显示52");
            SDK_apk.showNative3();
            var rand = SceneManager$1.RandomInt(10, 20) * 300;
            var bWin = rand > 15;
            Laya.timer.once(rand, this, function () {
                if (this.over == true)
                    return;
                this.GameOver(bWin);
            });
        }
        onHitPlayer(player) {
            if (player.id == SceneManager$1.player.id) {
                SceneManager$1.pause = true;
                script_player.onHit();
                this.clearAction();
                Laya.timer.once(1000, this, this.onPlayerDeath);
                return true;
            }
            var monster = player.getComponent(script_monster);
            monster.onHit();
            return false;
        }
        createItem() {
            let posList = [];
            let temp = null;
            for (var i = 0; i < SceneManager$1.itemPos.length; i++) {
                posList.push(i);
            }
            this.boxList = [];
            for (let i = 0; i < 3; i++) {
                let n = SceneManager$1.RandomInt(0, posList.length - 1);
                let pos = posList[n];
                posList.splice(n, 1);
                let modelPrefab = SceneManager$1.resModels.getChildByName("item");
                let item = Laya.Sprite3D.instantiate(modelPrefab, SceneManager$1.resScene);
                item.transform.position = SceneManager$1.itemPos[pos];
                let animator = item.getChildAt(0).getComponent(Laya.Animator);
                animator.play("Box_3_closed", 0, false);
                item.name = "box";
                this.boxList.push(item);
            }
            {
                let modelPrefab = SceneManager$1.resModels.getChildByName("Coin");
                this.Coin = Laya.Sprite3D.instantiate(modelPrefab, SceneManager$1.resScene);
                this.Coin.active = false;
            }
        }
        PushMessage(str) {
            this.messageList.push(str);
        }
        updateMessage() {
            if (this._message_text.visible == true)
                return;
            if (this.messageList.length == 0)
                return;
            var str = this.messageList.shift();
            this._message_text.text = str;
            this._message_text.scaleX = 0.7;
            this._message_text.scaleY = 0.7;
            this._message_text.visible = true;
            Laya.Tween.to(this._message_text, { scaleX: 1, scaleY: 1 }, 1000, null, Laya.Handler.create(this, function () {
                this._message_text.visible = false;
            }));
        }
    }

    class script_rocker extends Laya.Image {
        constructor() {
            super();

        }
        onDestroy() {
            console.log("onDestroy script_rocker");
        }
        onEnable() {
            this.RADIUS = 75;
            this.smallCircle = this.getChildAt(0);
            this.bigCircle = this;
            this.bigCircle.parent.on(Laya.Event.MOUSE_DOWN, this, this.onSmallClickDown);
            Laya.timer.loop(15, this, this.tick);
        }
        onDisable() {
            Laya.timer.clearAll(this);
            this.bigCircle.parent.off(Laya.Event.MOUSE_DOWN, this, this.onSmallClickDown);
            this.bigCircle.parent.off(Laya.Event.MOUSE_UP, this, this.onSmallClickUp);
            this.bigCircle.parent.off(Laya.Event.MOUSE_OUT, this, this.onSmallClickUp);
            this.bigCircle.parent.off(Laya.Event.MOUSE_MOVE, this, this.onSmallClickMove);
        }

        onSmallClickDown(e) {
            console.log(e.touchId);
            this.touchId = e.touchId;
            this.bigCircle.parent.on(Laya.Event.MOUSE_UP, this, this.onSmallClickUp);
            this.bigCircle.parent.on(Laya.Event.MOUSE_OUT, this, this.onSmallClickUp);
            this.bigCircle.parent.on(Laya.Event.MOUSE_MOVE, this, this.onSmallClickMove);
        }


        onSmallClickUp(e) {
            if (e.touchId != this.touchId)
                return;
            this.reset();
            if (SceneManager$1.pause == false)
                script_player.Idle();
        }
        reset() {
            // 取消鼠标移动事件
            this.bigCircle.parent.off(Laya.Event.MOUSE_UP, this, this.onSmallClickUp);
            this.bigCircle.parent.off(Laya.Event.MOUSE_OUT, this, this.onSmallClickUp);
            this.bigCircle.parent.off(Laya.Event.MOUSE_MOVE, this, this.onSmallClickMove);
            // 小圆返回中心位置
            this.smallCircle.x = this.bigCircle.width / 2;
            this.smallCircle.y = this.bigCircle.height / 2;

            this.touchId = -1;
        }
        onSmallClickMove(e) {
            // 鼠标与大圆中心x、y轴的距离
            if (e.touchId != this.touchId)
                return;

            var xx = Laya.stage.mouseX - (this.bigCircle.x + this.parent.x);
            var yy = Laya.stage.mouseY - (this.bigCircle.y + this.parent.y);
            // 勾股定理求斜边
            var obl = Math.sqrt(Math.pow(xx, 2) + Math.pow(yy, 2));
            // 求弧度
            var rad = this.getRad(xx, yy, obl);
            // 弧度转角度
            var angle = 180 / Math.PI * rad;
            // 在文本框中显示角度
            //console.log("angle:" + angle);
            // 限制小圆移动范围
            if (obl > this.RADIUS) {
                // // 当鼠标与大圆中心超过移动半径 RADIUS 时，停止小圆继续往外移动
                // // 通过三角形边与边的比例计算出小圆应该处于的位置
                var smallCircleX = (this.RADIUS * xx) / obl + 100;
                var smallCircleY = (this.RADIUS * yy) / obl + 100;
                this.smallCircle.pos(smallCircleX, smallCircleY);
            } else {
                // 小圆处于大圆之中时，与鼠标同一位置
                let x = xx + this.bigCircle.width / 2;
                let y = yy + this.bigCircle.height / 2;

                this.smallCircle.pos(x, y);
            }
        }
        /**
           * 求弧度函数
           * @param xx : x轴距离
           * @param yy : y轴距离
           * @param obl : 斜边
           */
        getRad(xx, yy, obl) {
            var rad = yy < 0 ? Math.acos(xx / obl) : (Math.PI * 2 - Math.acos(xx / obl));
            return rad;
        }

        tick() {
            if (SceneManager$1.pause) {
                this.reset();
            }
            if (SceneManager$1.gameUI && SceneManager$1.player && SceneManager$1.pause == false) {
                let x = this.smallCircle.x - 100;
                let y = this.smallCircle.y - 100;
                if (Math.abs(x) > 5 || Math.abs(y) > 5)
                    SceneManager$1.gameUI.playerMove(-x / 100, -y / 100);
                else
                    script_player.Idle();
            }

        }
    }

    class ui_loading extends Laya.Scene {
        constructor() {
            super();
        }

        onEnable() {
            console.log('加载场景开始');
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this._bar.value = 0;

            SceneManager$1.loadingUI = this;
            Laya.Browser.window.pageOrientation = "portrait";

            if (SceneManager$1.curScene == -1) {
                //初始化游戏
                this.InitRes();
            } else {// if (SceneManager.curScene == SceneManager.UI_MAIN) {
                //初始化场景
                this._init3d = 0;
                this.Init3D();
            }
        }

        //这里加载UI资源
        InitRes() {
            DataManager.Init();
        }

        //模型地址
        onDataInit() {
            var path = "res/unity/scene/LayaScene_model/Conventional/model.lh";
            let self = this;
            Laya.loader.create(path,
                Laya.Handler.create(this, function () {
                    let model = Laya.loader.getRes(path);
                    if (model) {
                        SceneManager$1.resModels = model;
                    }
                    self.loadOver();
                }), Laya.Handler.create(this, function (v) {
                    self._bar.value = v;
                }));
        }

        Init3D() {
            let id = "1"; // SceneManager.curStage
            let data = DataManager.stage[id];

            let self = this;
            Laya.loader.create(data.res,
                Laya.Handler.create(this, function () {
                    SceneManager$1.resScene = Laya.loader.getRes(data.res);
                    self.loadOver();
                }), Laya.Handler.create(this, function (v) {
                    self._bar.value = v;
                }));
        }

        // onDisable() {

        // }

        loadOver() {
            Laya.timer.clearAll(this);
            if (SceneManager$1.curScene == -1) {
                SDK_apk.Init(function () {
                    SceneManager$1.open(SceneManager$1.UI_MAIN);
                    console.log("显示单格子");
                    SDK_apk.showIcon();
                    SDK_apk.showBanner();
                });
            }
            else {
                SceneManager$1.open(SceneManager$1.UI_GAME);
            }
        }
    }

    class ui_main extends Laya.Scene {
        constructor() {
            super();
        }

        setYSSM() {
            DataManager.SetData("yingsishengming", 1);
            this.yingsisehngming.visible = false;
        }

        quitGame() {

        }

        startScrollText() {
            // this.prevX = this.sm_text.mouseX;
            this.prevY = this.YSSMstr.mouseY;
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.scrollText);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.finishScrollText);
        }
        /* 停止滚动文本 */
        finishScrollText() {
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.scrollText);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.finishScrollText);
        }
        /* 鼠标滚动文本 */
        scrollText() {
            var nowY = this.YSSMstr.mouseY;
            this.YSSMstr.scrollY += this.prevY - nowY;
            this.prevY = nowY;
        }

        onEnable() {
            console.log("主界面场景");
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            SceneManager$1.MapMenu = true;

            this.InitMainUI();
            this.InitStageUI();
            this.InitShopUI();
            this.InitAchievmentUI();
            this.InitFont();
            SceneManager$1.mainUI = this;

            this.InitModel();
            this.CreateName();

            console.log("xuhong进入主页面");
            SceneManager$1.showCP[2]++;
            if (SceneManager$1.showCP[2] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }
        }

        ResetModel() {
            this.model1.destroy();
            this.model2.destroy();
            let id = DataManager.GetData("Model");
            let data = DataManager.shop[id];
            {
                var modelPrefab = SceneManager$1.resModels.getChildByName(data.Model);
                console.log("*******************" + modelPrefab);
                this.model1 = Laya.Sprite3D.instantiate(modelPrefab, this.scene1);
                this.model1.transform.scale = new Laya.Vector3(1, 1, 1);
                this.model1.transform.position = new Laya.Vector3(0, 0, -3);
            }
            {
                var modelPrefab = SceneManager$1.resModels.getChildByName(data.Model);
                console.log("*******************1" + modelPrefab);
                this.model2 = Laya.Sprite3D.instantiate(modelPrefab, this.scene2);
                this.model2.transform.scale = new Laya.Vector3(1, 1, 1);
                this.model2.transform.position = new Laya.Vector3(0, 0, -3);
            }

        }
        InitModel() {
            this._playerName.text = DataManager.GetData("Name");
            let id = DataManager.GetData("Model");
            let data = DataManager.shop[id];
            {
                this.scene1 = Laya.stage.addChild(new Laya.Scene3D());
                var camera = this.scene1.addChild(new Laya.Camera(0, 0.1, 1000));
                //相机设置清楚标记,使用固定颜色
                camera.clearFlag = Laya.BaseCamera.CLEARFLAG_SOLIDCOLOR;
                //设置背景颜色
                camera.clearColor = new Laya.Vector4(0, 0, 0, 0);
                var renderTexture = new Laya.RenderTexture(400, 400, Laya.BaseTexture.FORMAT_R8G8B8A8, Laya.BaseTexture.FORMAT_DEPTHSTENCIL_NONE);
                // var renderTexture = new Laya.RenderTexture(1280, 720, Laya.BaseTexture.FORMAT_R8G8B8A8, Laya.BaseTexture.FORMAT_DEPTHSTENCIL_16_8);
                camera.renderTarget = renderTexture;
                camera.transform.position = new Laya.Vector3(0, 1.6, 0);

                // var renderTexture = new Laya.RenderTexture(1280, 720, Laya.BaseTexture.FORMAT_R8G8B8A8, Laya.BaseTexture.FORMAT_DEPTHSTENCIL_16_8);
                // camera.renderTarget = renderTexture;
                // camera.transform.position = new Laya.Vector3(0, 1.6, 0);
                // camera.transform.rotation = new Laya.Vector3(15 * Math.PI / 180, 0, 0);

                //渲染顺序
                //主界面模型
                var modelPrefab = SceneManager$1.resModels.getChildByName(data.Model);//无法读取Model的值
                this.model1 = Laya.Sprite3D.instantiate(modelPrefab, this.scene1);
                this.model1.transform.scale = new Laya.Vector3(1, 1, 1);//主界面角色模型的大小
                this.model1.transform.position = new Laya.Vector3(0, 0, -3);//主界面角色模型的位置
                // this.model1.transform.position = new Laya.Vector3(0, 0, -5);
                // var rotate = this.model1.transform.rotation;
                // rotate.y = 30 * Math.PI / 180;//主界面角色模型旋转角度
                // this.model1.transform.rotation = rotate;
                // this.model1.getComponent(Laya.Animator).play("Among_Walk");

                // this.model1.active = false;

                // // var modelPrefab = SceneManager.resModels.getChildByName("bear1");
                // var modelPrefab = SceneManager.resModels.getChildByName("Cloud_01");

                // let cloud = Laya.Sprite3D.instantiate(modelPrefab, this.scene1);
                // cloud.transform.scale = new Laya.Vector3(1, 1, 1);
                // cloud.transform.position = new Laya.Vector3(0, 1, -3);

                // var light = new Laya.DirectionLight()
                // // light.transform.rotation = new Laya.Vector3(-1, -1, -1)
                // // light.transform.rotation = new Laya.Quaternion(1, 50 * Math.PI / 180, 150 * Math.PI / 180, 0)
                // light.transform.rotation = new Laya.Quaternion(1, 30, 180, 0)
                // this.scene1.addChild(light);
                // console.log("Yy     ", light.transform.rotation)

                // scene.addChild(new Laya.DirectionLight());
                var rtex = new Laya.Texture(camera.renderTarget, Laya.Texture.DEF_UV);
                this._model.graphics.drawTexture(rtex);
            }
            {
                this.scene2 = Laya.stage.addChild(new Laya.Scene3D());
                var camera = this.scene2.addChild(new Laya.Camera(0, 0.1, 1000));
                //相机设置清楚标记,使用固定颜色
                camera.clearFlag = Laya.BaseCamera.CLEARFLAG_SOLIDCOLOR;
                //设置背景颜色
                camera.clearColor = new Laya.Vector4(0, 0, 0, 0);
                var renderTexture = new Laya.RenderTexture(400, 400, Laya.BaseTexture.FORMAT_R8G8B8A8, Laya.BaseTexture.FORMAT_DEPTHSTENCIL_NONE);
                camera.renderTarget = renderTexture;
                camera.transform.position = new Laya.Vector3(0, 1.6, 0);

                var modelPrefab = SceneManager$1.resModels.getChildByName(data.Model);
                this.model2 = Laya.Sprite3D.instantiate(modelPrefab, this.scene2);
                this.model2.transform.scale = new Laya.Vector3(1, 1, 1);
                this.model2.transform.position = new Laya.Vector3(0, 0, -4);
                var rotate = this.model2.transform.rotation;
                rotate.y = 30 * Math.PI / 180;
                this.model2.transform.rotation = rotate;
                //this.model2.getComponent(Laya.Animator).play("Among_Walk");;
                // scene.addChild(new Laya.DirectionLight());
                var rtex = new Laya.Texture(camera.renderTarget, Laya.Texture.DEF_UV);
                this._model2.graphics.drawTexture(rtex);
            }

            // this.showCloud();
            // Laya.timer.loop(200, this, this.showCloud)
            // Laya.timer.loop(20, this, this.update)
        }


        /**显示云彩上飘动画，模拟人物掉落 */
        showCloud() {
            let cloudName = "Cloud_01";
            let random = Math.random() * 3;
            if (random > 1) {
                cloudName = "Cloud_02";
            } else if (random > 2) {
                cloudName = "Cloud_03";
            }
            var modelPrefab = SceneManager$1.resModels.getChildByName(cloudName);
            let cloud = Laya.Sprite3D.instantiate(modelPrefab, this.scene1);
            cloud.transform.scale = new Laya.Vector3(1, 1, 1);
            cloud.transform.position = new Laya.Vector3(0, 0, -2);
            if (this.cloudList == null) {
                this.cloudList = [];
            }
            this.cloudList.push(cloud);
            console.log("YY     ", cloudName, cloud.active, this.cloudList.length);
        }
        update() {
            console.log("11111111111        ", this.cloudList.length);
            if (this.cloudList) {
                for (var i = 0; i < this.cloudList.length; i++) {
                    var cloud = this.cloudList[i];
                    var cloudPos = cloud.transform.position.clone();
                    cloudPos.y += 0.1;
                    cloud.transform.position = cloudPos;
                }
            }
        }
        release() {
            this.scene1.destroy(true);
            this.scene2.destroy(true);
        }
        InitFont() {
            // this._money1.font = "font2";
            // // this._money1.scaleX = 2;
            // // this._money1.scaleY = 2;
            // // this._money1.x = 71;
            // // this._money1.y = -5;

            // this._money2.font = "font2";
            // // this._money2.scaleX = 2;
            // // this._money2.scaleY = 2;
            // // this._money2.x = 71;
            // // this._money2.y = -5;

            // this._money3.font = "font2";
            // this._money3.scaleX = 2;
            // this._money3.scaleY = 2;
            // this._money3.x = 71;
            // this._money3.y = -5;
        }

        //商城界面返回
        InitShopUI() {
            this._ui_main_shop.width = Laya.stage.width;
            this._ui_main_shop.height = Laya.stage.height;

            this.btn_back_1.on(Laya.Event.CLICK, this, function () {
                if (this.needReset) {
                    this.ResetModel();
                    this.needReset = false;
                }
                this._ui_main_shop.visible = false;
                console.log("xuhong进入主页面");
                SceneManager$1.showCP[2]++;
                if (SceneManager$1.showCP[2] % 2 == 0) {
                    console.log("显示插屏");
                    SDK_apk.showNativeAd();
                }
            });

            //商城列表
            this._shoplist.hScrollBarSkin = "";
            this._shoplist.selectEnable = true;
            this._shoplist.selectHandler = new Laya.Handler(this, this.onSelect);

            this._btn_buy.on(Laya.Event.CLICK, this, this.onClickBuy);
            this._btn_equip.on(Laya.Event.CLICK, this, this.onClickEquip);
        }
        //点击装备
        onClickEquip() {
            let id = (this.select + 1) + "";
            DataManager.SetData("Model", id);
            this.setChoose1();
            this.needReset = true;
            this.onClickShop1();
        }
        //点击购买
        onClickBuy() {
            let id = (this.select + 1) + "";
            let data = DataManager.shop[id];
            if (false == DataManager.DelMoney(data.Price)) {
                Laya.Scene.open("showAsk.scene", false, "金币不足~");
                return;
            }
            DataManager.EventLogic(5);
            this.UpdateMoney();
            let has = DataManager.GetData("Has");
            has[id] = 1;
            DataManager.SetData("Has", has);
            this.setChoose1();
            this.onClickShop1();
        }
        //点击商城角色
        onSelect(index) {
            if (index == this.select)
                return;
            console.log("LLLLL:" + index);
            let obj = this._shoplist.array[this.select];
            obj["choose"]["visible"] = false;
            obj = this._shoplist.array[index];
            obj["choose"]["visible"] = true;
            this.select = index;
            this.setChoose(index);
        }

        setChoose(index) {
            if (index == null)
                index = this.select;
            let id = (index + 1) + "";
            let cur = DataManager.GetData("Model");
            let has = DataManager.GetData("Has");
            let b = has[id] != null;
            this._btn_buy.visible = !b;
            this._btn_equip.visible = b && (cur != id);
            let data = DataManager.shop[id];

            this._lab_price.text = data.Price + "";
            this._shop_model.skin = "shop/" + data.Card + ".png";
            this._shop_content.text = data.Text;
            this._shop_name.text = data.Name;
        }

        setChoose1(index) {
            if (index == null)
                index = this.select;
            let id = (index + 1) + "";
            let cur = DataManager.GetData("Model");
            let has = DataManager.GetData("Has");
            let b = has[id] != null;
            this._btn_buy.visible = !b;
            this._btn_equip.visible = b && (cur != id);
            let data = DataManager.shop[id];

            this._lab_price.text = data.Price + "";
            {
                this._shop_model.skin = "shop/" + data.Card + ".png";
            }
            this._shop_content.text = data.Text;
            this._shop_name.text = data.Name;
        }

        InitAchievmentUI() {
            this._ui_achievment.width = Laya.stage.width;
            this._ui_achievment.height = Laya.stage.height;
            this.btn_back_2.on(Laya.Event.CLICK, this, function () {
                this._ui_achievment.visible = false;
                this._ui_main.visible = true;
                console.log("xuhong进入主页面");
                SceneManager$1.showCP[2]++;
                if (SceneManager$1.showCP[2] % 2 == 0) {
                    console.log("显示插屏");
                    SDK_apk.showNativeAd();
                }
            });
            this._list2.vScrollBarSkin = "";
            this._list2.renderHandler = new Laya.Handler(this, this.updateItem);
        }
        onCloseName() {
            console.log("11111111111111111111");
            var name = this._inputName.text;
            if (name.length > 6)
                return;
            DataManager.SetData("Name", name);
            this._ui_name.visible = false;
            this.openGuide();
        }
        onClickRandomName() {
            this._inputName.text = SceneManager$1.RandomName();
        }
        CreateName() {
            let guide = DataManager.GetData("Guide");
            if (guide == 2) {
                return;
                this._ui_main.visible = true;
            }
            this._ui_main.visible = false;
            this._ui_name.visible = true;
            this.onClickRandomName();
        }
        openGuide() {
            DataManager.SetData("Guide", 2);
            this._guide.visible = true;
            this._gright.visible = true;
            this._gleft.visible = false;
            this._guide1.visible = true;
            this._guide2.visible = false;
            this._guide3.visible = false;
            this._g1.visible = true;
            this._g2.visible = false;
            this._g3.visible = false;
            this._gright.on(Laya.Event.CLICK, this, function () {
                this._guide3.visible = this._guide2.visible;
                this._guide2.visible = this._guide1.visible;
                this._guide1.visible = false;

                this._g1.visible = this._guide1.visible;
                this._g2.visible = this._guide2.visible;
                this._g3.visible = this._guide3.visible;
                this._gright.visible = !this._guide3.visible;
                this._gleft.visible = !this._guide1.visible;
            });
            this._gleft.on(Laya.Event.CLICK, this, function () {
                this._guide1.visible = this._guide2.visible;
                this._guide2.visible = this._guide3.visible;
                this._guide3.visible = false;
                this._gleft.visible = !this._guide1.visible;
                this._gright.visible = !this._guide3.visible;
                this._g1.visible = this._guide1.visible;
                this._g2.visible = this._guide2.visible;
                this._g3.visible = this._guide3.visible;
            });
            this._closeGuide.on(Laya.Event.CLICK, this, function () {
                this._guide.visible = false;
                this._ui_main.visible = true;
            });
        }
        onDisable() {

        }

        //主界面
        InitMainUI() {
            SceneManager$1.StopSound();
            SceneManager$1.PlayMusic();
            this._ui_main_start.on(Laya.Event.CLICK, this, this.onClickStart);
            this._ui_main_shop_btn.on(Laya.Event.CLICK, this, this.onClickShop);
            this._ui_main_achievment_btn.on(Laya.Event.CLICK, this, this.onClickAchievment);

            this.yszcBtn.on(Laya.Event.CLICK, this, function () {
                SDK_apk.showYSSM();
            });

            this.moreGame.on(Laya.Event.CLICK, this, function () {
                SDK_apk.goToMoreGame();
            });

            this.kfyxBtn.on(Laya.Event.CLICK, this, function () {
                SDK_apk.showEmail();
            });

            this.getGoldBtn.on(Laya.Event.CLICK, this, function () {
                console.log("显示视频");
                let self = this;
                SDK_apk.showVideoAD1(function () {
                    let curMoney = DataManager.GetData("Money");
                    curMoney = curMoney + 2000;
                    DataManager.SetData("Money", curMoney);
                    self.UpdateMoney();
                });
            });

            this._btn_seek.on(Laya.Event.CLICK, this, this.onClickSeek1);
            this._btn_hide.on(Laya.Event.CLICK, this, this.onClickHide1);
            this._btn_cancel.on(Laya.Event.CLICK, this.onClickCancel);
            this._btn_home.on(Laya.Event.CLICK, this, this.onClickBack);
            this.UpdateMoney();

            this._ui_model.width = Laya.stage.width;
            this._ui_model.height = Laya.stage.height;
            this._labNumber.text = "1/5";
            this._loadNumber = 1;

            this._randomName.on(Laya.Event.CLICK, this, this.onClickRandomName);
            this._btn_name.on(Laya.Event.CLICK, this, this.onCloseName);

            this.stageID = 1;
        }
        onClickCancel() {
            this._loading.visible = false;
            Laya.timer.clear(this, this.readyTimer);
        }

        onClickSeek1() {
            this.onClickSeek();
        }
        onClickHide1() {
            this.onClickHide();
        }

        onClickSeek() {
            SceneManager$1.model = 2;
            this.openReadyUI();
        }
        onClickHide() {
            SceneManager$1.model = 1;
            this.openReadyUI();
        }

        readyTimer() {
            if (this.readyNum < 5) {
                this.readyNum++;
            }
        }
        //场景加载、地图更换
        openReadyUI() {
            this._loading.visible = true;
            this.readyNum = 0;
            var self = this;
            Laya.timer.loop(500, this, this.readyTimer);
            var l = ["res/unity/scene/LayaScene_game_new1/Conventional/game_new1.ls",
                "res/unity/scene/LayaScene_game_new2/Conventional/game_new2.ls",
                "res/unity/scene/LayaScene_game_new3/Conventional/game_new3.ls"];
            var res = l[this.stageID - 1];
            this._bReady = false;
            Laya.loader.create(res, Laya.Handler.create(this, function () {
                SceneManager$1.resScene = Laya.loader.getRes(res);
                SceneManager$1.InitAreaInfo();
                self.checkLoading();
            }));
            Laya.timer.loop(500, this, this.onLoadTimer);
        }
        onLoadTimer() {
            this._loadNumber++;
            this._labNumber.text = this._loadNumber + "/5";
            if (this._loadNumber == 5) {
                this.checkLoading();
                this.timer.clear(this, this.onLoadTimer);
            }
        }
        checkLoading() {
            if (this._bReady == false) {
                this._bReady = true;
            } else {
                this.release();
                Laya.timer.clearAll(this);
                SceneManager$1.open(SceneManager$1.UI_GAME);
            }
        }

        UpdateMoney() {
            this._money1.text = DataManager.GetData("Money");
            this._money2.text = DataManager.GetData("Money");
            this._money3.text = DataManager.GetData("Money");
        }

        onClickStart() {
            //游戏地图选择
            this._ui_map.visible = true;
            console.log("xuhong进入地图选择界面");
            SceneManager$1.showCP[3]++;
            if (SceneManager$1.showCP[3] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }
        }

        onClickBack() {
            this._ui_model.visible = false;
            console.log("xuhong进入主界面");
            SceneManager$1.showCP[2]++;
            if (SceneManager$1.showCP[2] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }
        }

        onClickShop() {
            this._ui_main_shop.visible = true;
            console.log("xuhong进入商城界面");
            SceneManager$1.showCP[0]++;
            if (SceneManager$1.showCP[0] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }
            //初始化
            this._shoplist.array = [];
            let array = [];
            this.select = 0;
            let cur = DataManager.GetData("Model");
            let has = DataManager.GetData("Has");
            let select = (this.select + 1) + "";
            for (var key in DataManager.shop) {
                if (key == "0")
                    continue;
                //商店解锁和未解锁
                let data = DataManager.shop[key];
                var str = "已拥有";
                if (key == cur) {
                    str = "使用中";
                }
                else if (has[key]) {
                    str = "已拥有";
                }
                else {
                    str = "未拥有";
                }
                let obj = { icon: { "skin": "shop/" + data.Icon + ".png" }, choose: { visible: key == select }, lab_stat: { text: str } };
                array.push(obj);
            }
            this._shoplist.array = array;
            this.setChoose(this.select);
        }


        isshopUI() {
            if (this._ui_main_shop.visible) {
                return true;
            } else {
                return false;
            }
        }
        onClickShop1() {
            this._ui_main_shop.visible = true;
            //初始化
            this._shoplist.array = [];
            let array = [];
            this.select = 0;
            let cur = DataManager.GetData("Model");
            let has = DataManager.GetData("Has");
            let select = (this.select + 1) + "";
            for (var key in DataManager.shop) {
                if (key == "0")
                    continue;
                //商店解锁和未解锁
                let data = DataManager.shop[key];
                var str = "已拥有";
                if (key == cur) {
                    str = "使用中";
                }
                else if (has[key]) {
                    str = "已拥有";
                }
                else {
                    str = "未拥有";
                }
                let obj = { icon: { "skin": "shop/" + data.Icon + ".png" }, choose: { visible: key == select }, lab_stat: { text: str } };
                array.push(obj);

            }

            this._shoplist.array = array;
            this.setChoose1(this.select);
        }

        onClickAchievment() {
            this._ui_main.visible = false;
            this._ui_achievment.visible = true;
            console.log("xuhong进入成就页面");
            SceneManager$1.showCP[1]++;
            if (SceneManager$1.showCP[1] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }

            //初始化

            this._list2.array = [];
            let array = [];
            this.select = 0;
            let chengjiu = DataManager.GetData("Achievment");
            let array1 = [];
            let array2 = [];
            let array3 = [];
            for (var key in DataManager.achievment) {
                let data = DataManager.achievment[key];
                if (data.before != -1 && chengjiu[key] == null)
                    continue;
                let obj = {};
                obj['btn1'] = { visible: chengjiu[key] >= data.param };
                obj['btn2'] = { visible: chengjiu[key] == null || (chengjiu[key] < data.param && chengjiu[key] >= 0) };
                obj['btn3'] = { visible: chengjiu[key] == -1 };
                obj['title'] = { text: data.title };
                obj['content'] = { text: data.text };
                obj['reward'] = { text: data.reward };
                obj['labID'] = { text: key };
                var pro = 0;
                if (chengjiu[key]) {
                    pro = chengjiu[key];
                }
                obj['pro'] = { visible: pro >= 0, text: pro + "/" + data.param };
                if (chengjiu[key] == -1) {
                    array3.push(obj);
                }
                else if (chengjiu[key] == null || chengjiu[key] < data.param) {
                    array2.push(obj);
                }
                else {
                    array1.push(obj);
                }

            }
            for (var i = 0; i < array1.length; i++) {
                array.push(array1[i]);
            }
            for (var i = 0; i < array2.length; i++) {
                array.push(array2[i]);
            }
            for (var i = 0; i < array3.length; i++) {
                array.push(array3[i]);
            }

            this._list2.array = array;
        }
        updateItem(cell, index) {
            let btn = cell.getChildByName("btn1");
            let id = cell.getChildByName("labID").text;
            btn.offAll();
            if (btn.visible)
                btn.on(Laya.Event.CLICK, this, this.onClickReward, [id]);
        }

        onClickReward(id) {
            let data = DataManager.achievment[id];
            DataManager.AddMoney(data.reward);
            DataManager.CompleteAchievment(id);
            this.onClickAchievment();
        }

        //关卡选择界面
        InitStageUI() {
            this._btn_choose.on(Laya.Event.CLICK, this, this.onClickChoose);
            this._btn_back_map.on(Laya.Event.CLICK, this, function () {
                this._ui_map.visible = false;
                console.log("xuhong进入主界面");
                SceneManager$1.showCP[2]++;
                if (SceneManager$1.showCP[2] % 2 == 0) {
                    console.log("显示插屏");
                    SDK_apk.showNativeAd();
                }

            });
            this._map1.on(Laya.Event.CLICK, this, this.onClickMap, [1]);
            this._map2.on(Laya.Event.CLICK, this, this.onClickMap, [2]);
            this._map3.on(Laya.Event.CLICK, this, this.onClickMap, [3]);
            this._m1.visible = true;
            this._m2.visible = false;
            this._m3.visible = false;
        }
        onClickMap(idx) {
            this.stageID = idx;
            console.log("onClickMap" + idx);
            this._m1.visible = idx == 1;
            this._m2.visible = idx == 2;
            this._m3.visible = idx == 3;
        }
        onClickChoose() {
            this._ui_map.visible = true;
            this._ui_model.visible = true;
            console.log("xuhong进入模式选择");
            SceneManager$1.showCP[4]++;
            if (SceneManager$1.showCP[4] % 2 == 0) {
                console.log("显示插屏");
                SDK_apk.showNativeAd();
            }
        }
        // CreateStageItem(id, max) {
        //     let bg = new Laya.Image("ui/chooselevel_card.png");
        //     let icon = new Laya.Image("ui/1.png");
        //     icon.gray = id > max;

        //     bg.addChild(icon);
        //     icon.centerX = 0;
        //     icon.bottom = 5;
        //     if (id <= max)
        //         icon.on(Laya.Event.CLICK, this, this.onSelectStage, [id])
        //     return bg;

        // }
        // onSelectStage(id) {
        //     if (this.lastX != null)
        //         return;
        //     console.log("index:" + id);
        //     // let id = index + 1;
        //     // if (id > DataManager.GetData("curStage"))
        //     //     return;
        //     SceneManager.start(id);
        // }

        onClickLeft() {

        }
        onClickRight() {

        }

        onMouseUp() {
            this.onMouseOut();
        }
        onMouseDown(e) {

            this.lastX = Laya.stage.mouseX;
            this._stagebox.on(Laya.Event.MOUSE_MOVE, this, function (ee) {
                let curX = Laya.stage.mouseX;
                let offsetX = (curX - this.lastX) / 2;
                this.lastX = curX;
                this._stagebox.x += offsetX;
                if (this._stagebox.x < Laya.stage.width - this._stagebox.width - 50) {
                    this._stagebox.x = Laya.stage.width - this._stagebox.width - 50;
                }
                else if (this._stagebox.x > 50) {
                    this._stagebox.x = 50;
                }
                this._stage_bar_item.x = (this._stage_bar.width - this._stage_bar_item.width) * ((this._stagebox.x) / (Laya.stage.width - this._stagebox.width - 50));
            });
            this._stagebox.once(Laya.Event.MOUSE_OUT, this, this.onMouseOut);
            this._stagebox.once(Laya.Event.MOUSE_UP, this, this.onMouseUp);
        }
        onMouseOut(e) {
            this._stagebox.off(Laya.Event.MOUSE_OUT, this);
            this._stagebox.off(Laya.Event.MOUSE_MOVE, this);
            this.lastX = null;
        }
        InitLog() {
            this._btn.on(Laya.Event.CLICK, this, function () {
                this._log.visible = true;
            });
            this._btn_back.on(Laya.Event.CLICK, this, function () {
                this._log.visible = false;
            });
            this._list.vScrollBarSkin = "";
            this._list.array = [];
            let info = [];
            // info.push({ "lab"});
            this.addlog(info, "2020/11/11");
            this.addlog(info, "增加了人物下蹲动作，玩家可以躲在半人高的箱子后躲避追踪");
            this.addlog(info, "第二摄像机改为从正上方俯视玩家四周情况");
            this.addlog(info, "增加了商城和成就界面（未完成）");
            this.addlog(info, "优化了选择关卡界面的滑动效果");

            this.addlog(info, "2020/11/12");
            this.addlog(info, "增加了人物得行走，跑动区分，设置了体力消耗");
            this.addlog(info, "第二摄像机增加了切换视角功能，可以切换目标");
            this.addlog(info, "增强了BossAI，当脱离boss视野3秒后，boss回归巡逻状态");


            this.addlog(info, "2020/11/15");
            this.addlog(info, "增加了上成功逻辑可以更改玩家模型");
            this.addlog(info, "增加了新手指引");

            this.addlog(info, "2020/11/17");
            this.addlog(info, "游戏改版，去掉关卡，改成躲藏模式和搜寻模式");
            this.addlog(info, "完成躲藏模式的核心玩法和怪物AI");
            this.addlog(info, "增加了宝箱特效");
            this.addlog(info, "增加了字体");

            this.addlog(info, "2020/11/18");
            this.addlog(info, "增加了抓鬼模式");

            this._list.array = info;
        }
        addlog(info, string) {
            info.push({ lab: { text: string } });
        }
    }

    class ui_message extends Laya.Scene {
        constructor() {
            super();

        }

        onEnable() {
            console.log("onEnable");
            this._redLabel.visible = false;
            this._moneyDel.visible = false;
            this._moneyAdd.visible = false;
            SceneManager$1.messageUI = this;
        }
        onDisable() {
            console.log("onDisable");
            SceneManager$1.messageUI = null;
        }
        onOpened(param) {
            switch (param[0]) {
                case 1:  //通知
                    this.ShowRedInfo(param[1]);
                    break;
                case 2: // 减少钱
                    this.ShowMoneyDel(param[1]);
                    break;
                case 3: //增加钱
                    this.ShowMoneyAdd(param[1]);
                    break;
            }
        }
        ShowMoneyAdd(v) {
            this._moneyAdd.text = "金钱增加 " + v;
            this._moneyAdd.top = 200;
            this._moneyAdd.visible = true;
            Laya.Tween.to(this._moneyAdd, { top: 50 }, 1000, null, Laya.Handler.create(this, function () {
                this._moneyAdd.visible = false;
            }), 0, true, true);
        }
        ShowMoneyDel(v) {
            this._moneyDel.text = "金钱减少 " + v;
            this._moneyDel.top = 200;
            this._moneyDel.visible = true;
            Laya.Tween.to(this._moneyDel, { top: 50 }, 1000, null, Laya.Handler.create(this, function () {
                this._moneyDel.visible = false;
            }), 0, true, true);
        }
        ShowRedInfo(str) {
            this._redLabel.text = str;
            this._redLabel.top = 200;
            this._redLabel.visible = true;
            Laya.Tween.to(this._redLabel, { top: 50 }, 1000, null, Laya.Handler.create(this, function () {
                this._redLabel.visible = false;
            }), 0, true, true);
        }
    }

    class showAskJS extends Laya.Scene {

        constructor() {
            super();
        }


        onOpened(param) {
            this.tishiStr.text = param;
        }

        onEnable() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.zOrder = 999;
            setTimeout(() => {
                this.destroy();
            }, 1000);
        }

        onDisable() {
        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */

    class GameConfig {
        static init() {
            //注册Script或者Runtime引用
            let reg = Laya.ClassUtils.regClass;
    		reg("ui_game.js",ui_game);
    		reg("script_rocker.js",script_rocker);
    		reg("ui_loading.js",ui_loading);
    		reg("ui_main.js",ui_main);
    		reg("ui_message.js",ui_message);
    		reg("showAskJS.js",showAskJS);
        }
    }
    GameConfig.width = 1280;
    GameConfig.height = 720;
    GameConfig.scaleMode ="fixedheight";
    GameConfig.screenMode = "horizontal";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "loading.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;

    GameConfig.init();

    class Main {
    	constructor() {
    		//根据IDE设置初始化引擎		
    		if (window["Laya3D"]) Laya3D.init(GameConfig.width, GameConfig.height);
    		else Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
    		Laya["Physics"] && Laya["Physics"].enable();
    		Laya["DebugPanel"] && Laya["DebugPanel"].enable();
    		Laya.stage.scaleMode = GameConfig.scaleMode;
    		Laya.stage.screenMode = GameConfig.screenMode;
    		Laya.stage.alignV = GameConfig.alignV;
    		Laya.stage.alignH = GameConfig.alignH;
    		//兼容微信不支持加载scene后缀场景
    		Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;

    		//打开调试面板（通过IDE设置调试模式，或者url地址增加debug=true参数，均可打开调试面板）
    		if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") Laya.enableDebugPanel();
    		if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"]) Laya["PhysicsDebugDraw"].enable();
    		if (GameConfig.stat) Laya.Stat.show();
    		Laya.alertGlobalError(true);

    		//激活资源版本控制，version.json由IDE发布功能自动生成，如果没有也不影响后续流程
    		Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
    	}

    	onVersionLoaded() {
    		//激活大小图映射，加载小图的时候，如果发现小图在大图合集里面，则优先加载大图合集，而不是小图
    		Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
    	}

    	onConfigLoaded() {
    		//加载IDE指定的场景
    		SceneManager$1.init();
    		// GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
    	}
    }
    //激活启动类
    new Main();

}());
